module     p0_ddbar_neepdubar_d11h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p0_ddbar_neepdubar/helicity0/d11h0l1d.f90
   ! generator: haggies (1.1)
   use p0_ddbar_neepdubar_config, only: ki
   use p0_ddbar_neepdubar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d11
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_abbrevd11h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(deg.eq.0) then
         numerator = abb11n12
         return
      end if
      t1 = spvak1k2(iv1)
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb11n16+k2(iv1)*abb11n16+k6(iv1)*abb11n16+spvak1k&
         &6(iv1)*abb11n18+spvak3k2(iv1)*abb11n19+spvak5k2(iv1)*abb11n20+t1*abb11&
         &n17)
         return
      end if
      t2 = spvak1k2(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb11n15+spvak3k6(iv1)*t2*abb11n14+spv&
         &ak3k6(iv2)*t1*abb11n14+spvak5k6(iv1)*t2*abb11n13+spvak5k6(iv2)*t1*abb1&
         &1n13)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d11:
   subroutine     reconstruct_d11(coeffs)
      use p0_ddbar_neepdubar_groups, only: tensrec_info_group6
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group6), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_11:
      coeffs%coeffs_11%c0 = derivative(czip)
      coeffs%coeffs_11%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_11%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_11%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_11%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_11%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_11%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_11%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_11%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_11%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_11%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_11%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_11%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_11%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_11%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_11:
   end subroutine reconstruct_d11
!---#] subroutine reconstruct_d11:
end module p0_ddbar_neepdubar_d11h0l1d
