module     p0_ddbar_neepdubar_d62h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p0_ddbar_neepdubar/helicity0/d62h0l1d.f90
   ! generator: haggies (1.1)
   use p0_ddbar_neepdubar_config, only: ki
   use p0_ddbar_neepdubar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d62
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_abbrevd62h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t2 = (spvak3k2(1)*qshift(1)-spvak3k2(2)*qshift(2)-spvak3k2(3)*qshift(3)-sp&
      &vak3k2(4)*qshift(4))
      t3 = (spvak5k2(1)*qshift(1)-spvak5k2(2)*qshift(2)-spvak5k2(3)*qshift(3)-sp&
      &vak5k2(4)*qshift(4))
      t4 = (spvak3k6(1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-sp&
      &vak3k6(4)*qshift(4))
      t5 = (spvak1k2(1)*qshift(1)-spvak1k2(2)*qshift(2)-spvak1k2(3)*qshift(3)-sp&
      &vak1k2(4)*qshift(4))
      t6 = (spvak1k6(1)*qshift(1)-spvak1k6(2)*qshift(2)-spvak1k6(3)*qshift(3)-sp&
      &vak1k6(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (t1*abb62n12+t2*abb62n17+t3*abb62n18+t4*abb62n19+t5*abb62n2&
         &0+t6*abb62n21+t1*t5*abb62n14+t2*t6*abb62n16+t3*t6*abb62n13+t4*t5*abb62&
         &n15)
         return
      end if
      t7 = spvak1k2(iv1)
      t8 = spvak1k6(iv1)
      t9 = spvak3k2(iv1)
      t10 = spvak3k6(iv1)
      t11 = spvak5k2(iv1)
      t12 = spvak5k6(iv1)
      if(deg.eq.1) then
         numerator = (t10*abb62n19+t11*abb62n18+t12*abb62n12+t7*abb62n20+t8*abb6&
         &2n21+t9*abb62n17+t1*t7*abb62n14+t10*t5*abb62n15+t11*t6*abb62n13+t12*t5&
         &*abb62n14+t2*t8*abb62n16+t3*t8*abb62n13+t4*t7*abb62n15+t6*t9*abb62n16)
         return
      end if
      t1 = spvak1k2(iv2)
      t2 = spvak1k6(iv2)
      if(deg.eq.2) then
         numerator = (spvak3k2(iv2)*t8*abb62n16+spvak3k6(iv2)*t7*abb62n15+spvak5&
         &k2(iv2)*t8*abb62n13+spvak5k6(iv2)*t7*abb62n14+t1*t10*abb62n15+t1*t12*a&
         &bb62n14+t11*t2*abb62n13+t2*t9*abb62n16)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d62:
   subroutine     reconstruct_d62(coeffs)
      use p0_ddbar_neepdubar_groups, only: tensrec_info_group6
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group6), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_62:
      coeffs%coeffs_62%c0 = derivative(czip)
      coeffs%coeffs_62%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_62%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_62%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_62%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_62%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_62%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_62%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_62%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_62%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_62%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_62%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_62%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_62%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_62%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_62:
   end subroutine reconstruct_d62
!---#] subroutine reconstruct_d62:
end module p0_ddbar_neepdubar_d62h0l1d
