module     p0_ddbar_neepdubar_d58h1l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p0_ddbar_neepdubar/helicity1/d58h1l1.f90
   ! generator: haggies (1.1)
   use p0_ddbar_neepdubar_config, only: ki
   use p0_ddbar_neepdubar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p0_ddbar_neepdubar_groups, only: &
!           & sign => diagram58_sign, shift => diagram58_shift
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_abbrevd58h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d58
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k5
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d58 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t4 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t5 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4))
      t6 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      d58 = (t1*abb58n10+t2*abb58n3+t3*abb58n7+abb58n1*(Q(1)*spvak6k1(1)-Q(2)*sp&
      &vak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))+abb58n2*(Q(1)*spvak1k6(1)-Q(&
      &2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4))+t1*t4*abb58n12+t1*t5*ab&
      &b58n5+t1*t6*abb58n8+t2*t4*abb58n11+t2*t5*abb58n4+t2*t6*abb58n9+t3*t4*abb5&
      &8n13+t3*t5*abb58n6+t3*t6*abb58n8)
      numerator = cmplx(real(d58, ki), aimag(d58), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_abbrevd58h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d58
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k5
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d58 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t4 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t5 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4))
      t6 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      d58 = (t1*abb58n10+t2*abb58n3+t3*abb58n7+abb58n1*(Q(1)*spvak6k1(1)-Q(2)*sp&
      &vak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))+abb58n2*(Q(1)*spvak1k6(1)-Q(&
      &2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4))+t1*t4*abb58n12+t1*t5*ab&
      &b58n5+t1*t6*abb58n8+t2*t4*abb58n11+t2*t5*abb58n4+t2*t6*abb58n9+t3*t4*abb5&
      &8n13+t3*t5*abb58n6+t3*t6*abb58n8)

      numerator = cmplx(real(d58, ki), aimag(d58), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p0_ddbar_neepdubar_d58h1l1
