module     p0_ddbar_neepdubar_d58h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p0_ddbar_neepdubar/helicity1/d58h1l1d.f90
   ! generator: haggies (1.1)
   use p0_ddbar_neepdubar_config, only: ki
   use p0_ddbar_neepdubar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d58
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_abbrevd58h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      real(ki) :: t16
      real(ki) :: t17
      real(ki) :: t18
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t16 = dotproduct(qshift, qshift)
      t17 = dotproduct(k1, qshift)
      t18 = dotproduct(k6, qshift)
      t1 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t2 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t3 = (spvak3k6(1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-sp&
      &vak3k6(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (t16*abb58n18+t17*abb58n24+t18*abb58n27+abb58n15*(spvak6k1(&
         &1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-spvak6k1(4)*q&
         &shift(4))+abb58n23*(spvak1k6(1)*qshift(1)-spvak1k6(2)*qshift(2)-spvak1&
         &k6(3)*qshift(3)-spvak1k6(4)*qshift(4))+t1*t16*abb58n31+t1*t17*abb58n17&
         &+t1*t18*abb58n16+t16*t2*abb58n28+t16*t3*abb58n25+t17*t2*abb58n19+t17*t&
         &3*abb58n22+t18*t2*abb58n20+t18*t3*abb58n21)
         return
      end if
      t4 = k1(iv1)
      t5 = k6(iv1)
      t6 = qshift(iv1)
      t7 = spvak3k1(iv1)
      t8 = spvak3k4(iv1)
      t9 = spvak3k6(iv1)
      if(deg.eq.1) then
         numerator = (spvak1k6(iv1)*abb58n23+spvak6k1(iv1)*abb58n15+t4*abb58n24+&
         &t5*abb58n27+t6*abb58n30+t1*t4*abb58n17+t1*t5*abb58n16+t1*t6*abb58n32+t&
         &16*t7*abb58n31+t16*t8*abb58n28+t16*t9*abb58n25+t17*t7*abb58n17+t17*t8*&
         &abb58n19+t17*t9*abb58n22+t18*t7*abb58n16+t18*t8*abb58n20+t18*t9*abb58n&
         &21+t2*t4*abb58n19+t2*t5*abb58n20+t2*t6*abb58n29+t3*t4*abb58n22+t3*t5*a&
         &bb58n21+t3*t6*abb58n26)
         return
      end if
      t16 = d(iv1,iv2)
      t10 = spvak3k1(iv2)
      t11 = spvak3k4(iv2)
      t12 = spvak3k6(iv2)
      t13 = k1(iv2)
      t14 = k6(iv2)
      t15 = qshift(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t16*abb58n18+t1*t16*abb58n31+t16*t2*abb58n28+t16&
         &*t3*abb58n25)+t10*t4*abb58n17+t10*t5*abb58n16+t10*t6*abb58n32+t11*t4*a&
         &bb58n19+t11*t5*abb58n20+t11*t6*abb58n29+t12*t4*abb58n22+t12*t5*abb58n2&
         &1+t12*t6*abb58n26+t13*t7*abb58n17+t13*t8*abb58n19+t13*t9*abb58n22+t14*&
         &t7*abb58n16+t14*t8*abb58n20+t14*t9*abb58n21+t15*t7*abb58n32+t15*t8*abb&
         &58n29+t15*t9*abb58n26)
         return
      end if
      t17 = d(iv2,iv3)
      t18 = d(iv1,iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak3k1(iv3)*t16*abb58n31+spvak3k4(iv3)*t16*abb&
         &58n28+spvak3k6(iv3)*t16*abb58n25+t10*t18*abb58n31+t11*t18*abb58n28+t12&
         &*t18*abb58n25+t17*t7*abb58n31+t17*t8*abb58n28+t17*t9*abb58n25))
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d58:
   subroutine     reconstruct_d58(coeffs)
      use p0_ddbar_neepdubar_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_58:
      coeffs%coeffs_58%c0 = derivative(czip)
      coeffs%coeffs_58%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_58%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_58%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_58%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_58%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_58%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_58%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_58%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_58%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_58%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_58%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_58%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_58%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_58%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_58%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_58%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_58%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_58%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_58%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_58%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_58%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_58%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_58%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_58%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_58%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_58%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_58%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_58%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_58%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_58%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_58%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_58%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_58%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_58%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_58:
   end subroutine reconstruct_d58
!---#] subroutine reconstruct_d58:
end module p0_ddbar_neepdubar_d58h1l1d
