module     p0_ddbar_neepdubar_d5h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p0_ddbar_neepdubar/helicity1/d5h1l1d.f90
   ! generator: haggies (1.1)
   use p0_ddbar_neepdubar_config, only: ki
   use p0_ddbar_neepdubar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d5
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_abbrevd5h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      real(ki) :: t21
      real(ki) :: t22
      real(ki) :: t23
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(deg.eq.0) then
         numerator = abb5n32
         return
      end if
      t1 = k1(iv1)
      t2 = k2(iv1)
      t3 = k5(iv1)
      t4 = spvak2k6(iv1)
      t5 = spvak3k4(iv1)
      t6 = spvak3k6(iv1)
      t7 = spvak5k1(iv1)
      t8 = spvak5k6(iv1)
      if(deg.eq.1) then
         numerator = (t1*abb5n48+t2*abb5n47+t3*abb5n45+t4*abb5n61+t5*abb5n52+t6*&
         &abb5n50+t7*abb5n39+t8*abb5n51)
         return
      end if
      t21 = d(iv1,iv2)
      t9 = spvak2k1(iv2)
      t10 = spvak3k6(iv2)
      t11 = spvak5k6(iv2)
      t12 = k1(iv2)
      t13 = spvak2k1(iv1)
      t14 = spvak3k4(iv2)
      t15 = spvak5k1(iv2)
      t16 = k2(iv2)
      t17 = k5(iv2)
      t18 = t14*t4
      t19 = spvak2k6(iv2)
      t20 = t19*t5
      if(deg.eq.2) then
         numerator = (t18*abb5n60+t20*abb5n60+(2.0_ki)*t21*abb5n46+spvak1k6(iv1)&
         &*t15*abb5n57+spvak1k6(iv2)*t7*abb5n57+spvak2k5(iv1)*t15*abb5n35+spvak2&
         &k5(iv2)*t7*abb5n35+t1*t10*abb5n53+t1*t11*abb5n58+t1*t9*abb5n34+t10*t2*&
         &abb5n53+t10*t3*abb5n55+t10*t7*abb5n38+t11*t2*abb5n58+t11*t3*abb5n56+t1&
         &1*t7*abb5n43+t12*t13*abb5n34+t12*t6*abb5n53+t12*t8*abb5n58+t13*t14*abb&
         &5n40+t13*t15*abb5n59+t13*t16*abb5n34+t13*t17*abb5n37+t14*t2*abb5n49+t1&
         &5*t2*abb5n41+t15*t4*abb5n44+t15*t6*abb5n38+t15*t8*abb5n43+t16*t5*abb5n&
         &49+t16*t6*abb5n53+t16*t7*abb5n41+t16*t8*abb5n58+t17*t6*abb5n55+t17*t8*&
         &abb5n56+t19*t7*abb5n44+t2*t9*abb5n34+t3*t9*abb5n37+t5*t9*abb5n40+t7*t9&
         &*abb5n59)
         return
      end if
      t22 = d(iv2,iv3)
      t23 = d(iv1,iv3)
      t1 = spvak5k1(iv3)
      t2 = spvak3k4(iv3)
      t3 = spvak2k6(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak2k1(iv3)*t21*abb5n36+spvak3k6(iv3)*t21*abb5&
         &n54+spvak5k6(iv3)*t21*abb5n57+t1*t21*abb5n42+t10*t23*abb5n54+t11*t23*a&
         &bb5n57+t13*t22*abb5n36+t15*t23*abb5n42+t22*t6*abb5n54+t22*t7*abb5n42+t&
         &22*t8*abb5n57+t23*t9*abb5n36)+t1*t18*abb5n33+t1*t20*abb5n33+t14*t3*t7*&
         &abb5n33+t15*t2*t4*abb5n33+t15*t3*t5*abb5n33+t19*t2*t7*abb5n33)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d5:
   subroutine     reconstruct_d5(coeffs)
      use p0_ddbar_neepdubar_groups, only: tensrec_info_group6
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group6), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_5:
      coeffs%coeffs_5%c0 = derivative(czip)
      coeffs%coeffs_5%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_5%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_5%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_5%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_5%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_5%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_5%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_5%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_5%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_5%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_5%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_5%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_5%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_5%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_5%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_5%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_5%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_5%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_5%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_5%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_5%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_5%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_5%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_5%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_5%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_5%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_5%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_5%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_5%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_5%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_5%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_5%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_5%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_5%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_5:
   end subroutine reconstruct_d5
!---#] subroutine reconstruct_d5:
end module p0_ddbar_neepdubar_d5h1l1d
