module     p0_ddbar_neepdubar_d62h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p0_ddbar_neepdubar/helicity1/d62h1l1d.f90
   ! generator: haggies (1.1)
   use p0_ddbar_neepdubar_config, only: ki
   use p0_ddbar_neepdubar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d62
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_abbrevd62h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t2 = (spvak3k6(1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-sp&
      &vak3k6(4)*qshift(4))
      t3 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (t1*abb62n6+t2*abb62n9+t1*t3*abb62n7+t2*t3*abb62n8)
         return
      end if
      t4 = spvak3k6(iv1)
      t5 = spvak5k6(iv1)
      t6 = spvak2k1(iv1)
      if(deg.eq.1) then
         numerator = (t4*abb62n9+t5*abb62n6+t1*t6*abb62n7+t2*t6*abb62n8+t3*t4*ab&
         &b62n8+t3*t5*abb62n7)
         return
      end if
      t1 = spvak2k1(iv2)
      if(deg.eq.2) then
         numerator = (spvak3k6(iv2)*t6*abb62n8+spvak5k6(iv2)*t6*abb62n7+t1*t4*ab&
         &b62n8+t1*t5*abb62n7)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d62:
   subroutine     reconstruct_d62(coeffs)
      use p0_ddbar_neepdubar_groups, only: tensrec_info_group6
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group6), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_62:
      coeffs%coeffs_62%c0 = derivative(czip)
      coeffs%coeffs_62%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_62%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_62%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_62%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_62%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_62%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_62%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_62%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_62%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_62%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_62%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_62%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_62%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_62%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_62:
   end subroutine reconstruct_d62
!---#] subroutine reconstruct_d62:
end module p0_ddbar_neepdubar_d62h1l1d
