module     p7_udbar_neepuubar_d53h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p7_udbar_neepuubar/helicity0/d53h0l1d.f90
   ! generator: haggies (1.1)
   use p7_udbar_neepuubar_config, only: ki
   use p7_udbar_neepuubar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d53
contains

!---#[ function derivative:
   function derivative(mu2, i1) result(numerator)
      use p7_udbar_neepuubar_globalsl1, only: epspow
      use p7_udbar_neepuubar_kinematics
      use p7_udbar_neepuubar_abbrevd53h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      complex(ki) :: numerator
      complex(ki) :: loc
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(deg.eq.0) then
         numerator = (abb53n11+abb53n20*(spvak2k1(1)*qshift(1)-spvak2k1(2)*qshif&
         &t(2)-spvak2k1(3)*qshift(3)-spvak2k1(4)*qshift(4))+abb53n21*(spvak6k1(1&
         &)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-spvak6k1(4)*qs&
         &hift(4))+abb53n22*(spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k&
         &4(3)*qshift(3)-spvak2k4(4)*qshift(4))+abb53n23*(spvak6k4(1)*qshift(1)-&
         &spvak6k4(2)*qshift(2)-spvak6k4(3)*qshift(3)-spvak6k4(4)*qshift(4))+abb&
         &53n24*dotproduct(k1, qshift)+abb53n25*dotproduct(k3, qshift)+abb53n25*&
         &dotproduct(k4, qshift)+abb53n26*(spvak3k4(1)*qshift(1)-spvak3k4(2)*qsh&
         &ift(2)-spvak3k4(3)*qshift(3)-spvak3k4(4)*qshift(4))+abb53n27*(spvak3k1&
         &(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-spvak3k1(4)*&
         &qshift(4)))
         return
      end if
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb53n15+k3(iv1)*abb53n14+k4(iv1)*abb53n14+spvak2k&
         &1(iv1)*abb53n19+spvak2k4(iv1)*abb53n17+spvak3k1(iv1)*abb53n12+spvak3k4&
         &(iv1)*abb53n13+spvak6k1(iv1)*abb53n18+spvak6k4(iv1)*abb53n16)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d53:
   subroutine     reconstruct_d53(coeffs)
      use p7_udbar_neepuubar_groups, only: tensrec_info_group6
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group6), intent(out) :: coeffs
      ! rank 1 case:
      !---[# reconstruct coeffs%coeffs_53:
      coeffs%coeffs_53%c0 = derivative(czip)
      coeffs%coeffs_53%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_53%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_53%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_53%c1(4,1) = -derivative(czip,4)
      !---#] reconstruct coeffs%coeffs_53:
   end subroutine reconstruct_d53
!---#] subroutine reconstruct_d53:
end module p7_udbar_neepuubar_d53h0l1d
