module     p7_udbar_neepuubar_abbrevd64h1
   use p7_udbar_neepuubar_config, only: ki
   use p7_udbar_neepuubar_globalsh1
   implicit none
   private
   complex(ki), public :: abb64n1
   complex(ki), public :: abb64n2
   complex(ki), public :: rat2d64
   complex(ki), public :: abb64n4
   complex(ki), public :: abb64n5
   complex(ki), public :: abb64n6
   complex(ki), public :: abb64n7
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   real(ki) :: t12
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p7_udbar_neepuubar_config, only: deltaOS
      use p7_udbar_neepuubar_kinematics
      use p7_udbar_neepuubar_model
      use p7_udbar_neepuubar_color, only: TR
      use p7_udbar_neepuubar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c2*i_
      t3 = TR*spbk6k1
      t3 = t3*t3
      t4 = es234*NC*t1
      t5 = t2*spak1k5*spak2k3
      t6 = c1*i_
      t7 = t3*t6*spak1k2*spak2k3*spak5k6*spbk4k2
      t1 = es234*t1
      t8 = t3*t6*spak1k3*spak2k3*spak5k6*spbk4k3
      t9 = t6*spak1k5*spak2k3
      t10 = t3*t9*spak2k6*spbk4k2
      t9 = t3*t9*spak3k6*spbk4k3
      t11 = NC*NC*t1
      abb64n1 = ((8.0_ki)*(t3/t4*t5*spak3k6*spbk4k3+t2*t3/t4*spak1k2*spak2k3*spa&
      &k5k6*spbk4k2-(t2*t3/t4*spak1k3*spak2k3*spak5k6*spbk4k3+t3/t4*t5*spak2k6*s&
      &pbk4k2))+(4.0_ki)*(t10/t1+t8/t1+t10/t11+t8/t11-(t9/t11+t7/t11+t9/t1+t7/t1&
      &)))
      t2 = t2*spak2k3
      t12 = TR*TR
      t3 = t6*spak2k3
      t5 = t12*t3*spak2k5*spbk4k2*spbk6k1
      t3 = t12*t3*spak3k5*spbk4k3*spbk6k1
      abb64n2 = ((16.0_ki)*(t12*t2/t4*spak3k5*spbk4k3*spbk6k1-t12*t2/t4*spak2k5*&
      &spbk4k2*spbk6k1)+(8.0_ki)*(t5/t1+t5/t11-(t3/t11+t3/t1)))
      rat2d64 = 0
      rat2 = rat2 + rat2d64
      abb64n4 = abb64n1
      abb64n5 = abb64n2
      abb64n6 = -(abb64n2)
      abb64n7 = (-2.0_ki)*abb64n2
   end subroutine
end module p7_udbar_neepuubar_abbrevd64h1
