module     p7_udbar_neepuubar_d65h1l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p7_udbar_neepuubar/helicity1/d65h1l1.f90
   ! generator: haggies (1.1)
   use p7_udbar_neepuubar_config, only: ki
   use p7_udbar_neepuubar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p7_udbar_neepuubar_groups, only: &
!           & sign => diagram65_sign, shift => diagram65_shift
      use p7_udbar_neepuubar_globalsl1, only: epspow
      use p7_udbar_neepuubar_kinematics
      use p7_udbar_neepuubar_abbrevd65h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d65
      complex(ki) :: t1
      complex(ki) :: t2

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k2
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d65 = 0.0_ki
      t1 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t2 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      d65 = (abb65n1+t1*abb65n2+t2*abb65n4+abb65n3*(Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k&
      &2(3)-Q(4)*k2(4))+t1*abb65n5*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak&
      &2k4(3)-Q(4)*spvak2k4(4))+t1*abb65n8*(Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(&
      &3)*spvak2k6(3)-Q(4)*spvak2k6(4))+t2*abb65n10*(Q(1)*spvak3k4(1)-Q(2)*spvak&
      &3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))+t2*abb65n11*(Q(1)*spvak3k6(1)-Q&
      &(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4))+t2*abb65n6*(Q(1)*spvak&
      &5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4))+t2*abb65n7*(Q(&
      &1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))+t2*abb65n7*(Q(1)*k4(1)-Q(2)*k4&
      &(2)-Q(3)*k4(3)-Q(4)*k4(4))+t2*abb65n7*(Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q&
      &(4)*k6(4))+t2*abb65n9*(Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)&
      &-Q(4)*spvak5k6(4)))
      numerator = cmplx(real(d65, ki), aimag(d65), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p7_udbar_neepuubar_globalsl1, only: epspow
      use p7_udbar_neepuubar_kinematics
      use p7_udbar_neepuubar_abbrevd65h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d65
      complex(ki) :: t1
      complex(ki) :: t2

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k2
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d65 = 0.0_ki
      t1 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t2 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      d65 = (abb65n1+t1*abb65n2+t2*abb65n4+abb65n3*(Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k&
      &2(3)-Q(4)*k2(4))+t1*abb65n5*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak&
      &2k4(3)-Q(4)*spvak2k4(4))+t1*abb65n8*(Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(&
      &3)*spvak2k6(3)-Q(4)*spvak2k6(4))+t2*abb65n10*(Q(1)*spvak3k4(1)-Q(2)*spvak&
      &3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))+t2*abb65n11*(Q(1)*spvak3k6(1)-Q&
      &(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4))+t2*abb65n6*(Q(1)*spvak&
      &5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4))+t2*abb65n7*(Q(&
      &1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))+t2*abb65n7*(Q(1)*k4(1)-Q(2)*k4&
      &(2)-Q(3)*k4(3)-Q(4)*k4(4))+t2*abb65n7*(Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q&
      &(4)*k6(4))+t2*abb65n9*(Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)&
      &-Q(4)*spvak5k6(4)))

      numerator = cmplx(real(d65, ki), aimag(d65), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p7_udbar_neepuubar_d65h1l1
