module     p7_udbar_neepuubar_d71h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p7_udbar_neepuubar/helicity1/d71h1l1d.f90
   ! generator: haggies (1.1)
   use p7_udbar_neepuubar_config, only: ki
   use p7_udbar_neepuubar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d71
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p7_udbar_neepuubar_globalsl1, only: epspow
      use p7_udbar_neepuubar_kinematics
      use p7_udbar_neepuubar_abbrevd71h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      real(ki) :: t15
      real(ki) :: t16
      real(ki) :: t17
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k3-k6-k5-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t2 = (spvak3k6(1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-sp&
      &vak3k6(4)*qshift(4))
      t3 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t4 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t5 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t15 = dotproduct(k3, qshift)
      t16 = dotproduct(k4, qshift)
      t17 = dotproduct(k6, qshift)
      if(deg.eq.0) then
         numerator = (abb71n14+t1*abb71n25+abb71n17*dotproduct(qshift, qshift)+a&
         &bb71n21*(spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshif&
         &t(3)-spvak2k1(4)*qshift(4))+abb71n22*(spvak3k1(1)*qshift(1)-spvak3k1(2&
         &)*qshift(2)-spvak3k1(3)*qshift(3)-spvak3k1(4)*qshift(4))+abb71n24*dotp&
         &roduct(k5, qshift)+t1*t15*abb71n20+t1*t16*abb71n20+t1*t17*abb71n20+t1*&
         &t2*abb71n15+t1*t3*abb71n16+t1*t4*abb71n18+t1*t5*abb71n19)
         return
      end if
      t6 = spvak5k1(iv1)
      t7 = k3(iv1)
      t8 = k4(iv1)
      t9 = k6(iv1)
      t10 = spvak2k4(iv1)
      t11 = spvak2k6(iv1)
      t12 = spvak3k4(iv1)
      t13 = spvak3k6(iv1)
      t14 = t6*abb71n20
      if(deg.eq.1) then
         numerator = (k5(iv1)*abb71n24+qshift(iv1)*abb71n23+spvak2k1(iv1)*abb71n&
         &21+spvak3k1(iv1)*abb71n22+t14*t15+t14*t16+t14*t17+t6*abb71n25+t1*t10*a&
         &bb71n18+t1*t11*abb71n16+t1*t12*abb71n19+t1*t13*abb71n15+t1*t7*abb71n20&
         &+t1*t8*abb71n20+t1*t9*abb71n20+t2*t6*abb71n15+t3*t6*abb71n16+t4*t6*abb&
         &71n18+t5*t6*abb71n19)
         return
      end if
      t1 = spvak5k1(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb71n17+k3(iv2)*t6*abb71n20+k4(iv2)*t&
         &6*abb71n20+k6(iv2)*t6*abb71n20+spvak2k4(iv2)*t6*abb71n18+spvak2k6(iv2)&
         &*t6*abb71n16+spvak3k4(iv2)*t6*abb71n19+spvak3k6(iv2)*t6*abb71n15+t1*t1&
         &0*abb71n18+t1*t11*abb71n16+t1*t12*abb71n19+t1*t13*abb71n15+t1*t7*abb71&
         &n20+t1*t8*abb71n20+t1*t9*abb71n20)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d71:
   subroutine     reconstruct_d71(coeffs)
      use p7_udbar_neepuubar_groups, only: tensrec_info_group7
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group7), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_71:
      coeffs%coeffs_71%c0 = derivative(czip)
      coeffs%coeffs_71%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_71%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_71%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_71%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_71%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_71%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_71%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_71%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_71%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_71%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_71%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_71%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_71%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_71%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_71:
   end subroutine reconstruct_d71
!---#] subroutine reconstruct_d71:
end module p7_udbar_neepuubar_d71h1l1d
