module     p7_udbar_neepuubar_golem95h1
   use precision_golem, only: ki_gol => ki
   use p7_udbar_neepuubar_config, only: ki
   implicit none
   private
   interface reconstruct_group
      module procedure reconstruct_group0
      module procedure reconstruct_group1
      module procedure reconstruct_group2
      module procedure reconstruct_group3
      module procedure reconstruct_group4
      module procedure reconstruct_group5
      module procedure reconstruct_group6
      module procedure reconstruct_group7
   end interface

   public :: reconstruct_group
contains
!---#[ subroutine reconstruct_group0:
subroutine     reconstruct_group0(coeffs)
   use tens_rec
   use p7_udbar_neepuubar_config
   use p7_udbar_neepuubar_groups, only: tensrec_info_group0
   use p7_udbar_neepuubar_d39h1l1, only: numerator_d39 => numerator_golem95
   use p7_udbar_neepuubar_d39h1l1d, only: reconstruct_d39
   implicit none
   type(tensrec_info_group0), intent(out) :: coeffs
   !------#[ Diagram 39:
      if (tens_rec_by_derivatives) then
         call reconstruct_d39(coeffs)
      else
         call reconstruct2(numerator_d39, coeffs%coeffs_39)
      end if
   !------#] Diagram 39:
end subroutine reconstruct_group0
!---#] subroutine reconstruct_group0:
!---#[ subroutine reconstruct_group1:
subroutine     reconstruct_group1(coeffs)
   use tens_rec
   use p7_udbar_neepuubar_config
   use p7_udbar_neepuubar_groups, only: tensrec_info_group1
   use p7_udbar_neepuubar_d23h1l1, only: numerator_d23 => numerator_golem95
   use p7_udbar_neepuubar_d23h1l1d, only: reconstruct_d23
   implicit none
   type(tensrec_info_group1), intent(out) :: coeffs
   !------#[ Diagram 23:
      if (tens_rec_by_derivatives) then
         call reconstruct_d23(coeffs)
      else
         call reconstruct2(numerator_d23, coeffs%coeffs_23)
      end if
   !------#] Diagram 23:
end subroutine reconstruct_group1
!---#] subroutine reconstruct_group1:
!---#[ subroutine reconstruct_group2:
subroutine     reconstruct_group2(coeffs)
   use tens_rec
   use p7_udbar_neepuubar_config
   use p7_udbar_neepuubar_groups, only: tensrec_info_group2
   use p7_udbar_neepuubar_d3h1l1, only: numerator_d3 => numerator_golem95
   use p7_udbar_neepuubar_d3h1l1d, only: reconstruct_d3
   implicit none
   type(tensrec_info_group2), intent(out) :: coeffs
   !------#[ Diagram 3:
      if (tens_rec_by_derivatives) then
         call reconstruct_d3(coeffs)
      else
         call reconstruct3(numerator_d3, coeffs%coeffs_3)
      end if
   !------#] Diagram 3:
end subroutine reconstruct_group2
!---#] subroutine reconstruct_group2:
!---#[ subroutine reconstruct_group3:
subroutine     reconstruct_group3(coeffs)
   use tens_rec
   use p7_udbar_neepuubar_config
   use p7_udbar_neepuubar_groups, only: tensrec_info_group3
   use p7_udbar_neepuubar_d5h1l1, only: numerator_d5 => numerator_golem95
   use p7_udbar_neepuubar_d5h1l1d, only: reconstruct_d5
   implicit none
   type(tensrec_info_group3), intent(out) :: coeffs
   !------#[ Diagram 5:
      if (tens_rec_by_derivatives) then
         call reconstruct_d5(coeffs)
      else
         call reconstruct3(numerator_d5, coeffs%coeffs_5)
      end if
   !------#] Diagram 5:
end subroutine reconstruct_group3
!---#] subroutine reconstruct_group3:
!---#[ subroutine reconstruct_group4:
subroutine     reconstruct_group4(coeffs)
   use tens_rec
   use p7_udbar_neepuubar_config
   use p7_udbar_neepuubar_groups, only: tensrec_info_group4
   use p7_udbar_neepuubar_d58h1l1, only: numerator_d58 => numerator_golem95
   use p7_udbar_neepuubar_d58h1l1d, only: reconstruct_d58
   use p7_udbar_neepuubar_d59h1l1, only: numerator_d59 => numerator_golem95
   use p7_udbar_neepuubar_d59h1l1d, only: reconstruct_d59
   use p7_udbar_neepuubar_d64h1l1, only: numerator_d64 => numerator_golem95
   use p7_udbar_neepuubar_d64h1l1d, only: reconstruct_d64
   implicit none
   type(tensrec_info_group4), intent(out) :: coeffs
   !------#[ Diagram 58:
      if (tens_rec_by_derivatives) then
         call reconstruct_d58(coeffs)
      else
         call reconstruct3(numerator_d58, coeffs%coeffs_58)
      end if
   !------#] Diagram 58:
   !------#[ Diagram 59:
      if (tens_rec_by_derivatives) then
         call reconstruct_d59(coeffs)
      else
         call reconstruct2(numerator_d59, coeffs%coeffs_59)
      end if
   !------#] Diagram 59:
   !------#[ Diagram 64:
      if (tens_rec_by_derivatives) then
         call reconstruct_d64(coeffs)
      else
         call reconstruct2(numerator_d64, coeffs%coeffs_64)
      end if
   !------#] Diagram 64:
end subroutine reconstruct_group4
!---#] subroutine reconstruct_group4:
!---#[ subroutine reconstruct_group5:
subroutine     reconstruct_group5(coeffs)
   use tens_rec
   use p7_udbar_neepuubar_config
   use p7_udbar_neepuubar_groups, only: tensrec_info_group5
   use p7_udbar_neepuubar_d56h1l1, only: numerator_d56 => numerator_golem95
   use p7_udbar_neepuubar_d56h1l1d, only: reconstruct_d56
   use p7_udbar_neepuubar_d61h1l1, only: numerator_d61 => numerator_golem95
   use p7_udbar_neepuubar_d61h1l1d, only: reconstruct_d61
   use p7_udbar_neepuubar_d66h1l1, only: numerator_d66 => numerator_golem95
   use p7_udbar_neepuubar_d66h1l1d, only: reconstruct_d66
   implicit none
   type(tensrec_info_group5), intent(out) :: coeffs
   !------#[ Diagram 56:
      if (tens_rec_by_derivatives) then
         call reconstruct_d56(coeffs)
      else
         call reconstruct3(numerator_d56, coeffs%coeffs_56)
      end if
   !------#] Diagram 56:
   !------#[ Diagram 61:
      if (tens_rec_by_derivatives) then
         call reconstruct_d61(coeffs)
      else
         call reconstruct2(numerator_d61, coeffs%coeffs_61)
      end if
   !------#] Diagram 61:
   !------#[ Diagram 66:
      if (tens_rec_by_derivatives) then
         call reconstruct_d66(coeffs)
      else
         call reconstruct2(numerator_d66, coeffs%coeffs_66)
      end if
   !------#] Diagram 66:
end subroutine reconstruct_group5
!---#] subroutine reconstruct_group5:
!---#[ subroutine reconstruct_group6:
subroutine     reconstruct_group6(coeffs)
   use tens_rec
   use p7_udbar_neepuubar_config
   use p7_udbar_neepuubar_groups, only: tensrec_info_group6
   use p7_udbar_neepuubar_d2h1l1, only: numerator_d2 => numerator_golem95
   use p7_udbar_neepuubar_d2h1l1d, only: reconstruct_d2
   use p7_udbar_neepuubar_d4h1l1, only: numerator_d4 => numerator_golem95
   use p7_udbar_neepuubar_d4h1l1d, only: reconstruct_d4
   use p7_udbar_neepuubar_d13h1l1, only: numerator_d13 => numerator_golem95
   use p7_udbar_neepuubar_d13h1l1d, only: reconstruct_d13
   use p7_udbar_neepuubar_d18h1l1, only: numerator_d18 => numerator_golem95
   use p7_udbar_neepuubar_d18h1l1d, only: reconstruct_d18
   use p7_udbar_neepuubar_d53h1l1, only: numerator_d53 => numerator_golem95
   use p7_udbar_neepuubar_d53h1l1d, only: reconstruct_d53
   use p7_udbar_neepuubar_d57h1l1, only: numerator_d57 => numerator_golem95
   use p7_udbar_neepuubar_d57h1l1d, only: reconstruct_d57
   use p7_udbar_neepuubar_d60h1l1, only: numerator_d60 => numerator_golem95
   use p7_udbar_neepuubar_d60h1l1d, only: reconstruct_d60
   implicit none
   type(tensrec_info_group6), intent(out) :: coeffs
   !------#[ Diagram 2:
      if (tens_rec_by_derivatives) then
         call reconstruct_d2(coeffs)
      else
         call reconstruct3(numerator_d2, coeffs%coeffs_2)
      end if
   !------#] Diagram 2:
   !------#[ Diagram 4:
      if (tens_rec_by_derivatives) then
         call reconstruct_d4(coeffs)
      else
         call reconstruct3(numerator_d4, coeffs%coeffs_4)
      end if
   !------#] Diagram 4:
   !------#[ Diagram 13:
      if (tens_rec_by_derivatives) then
         call reconstruct_d13(coeffs)
      else
         call reconstruct2(numerator_d13, coeffs%coeffs_13)
      end if
   !------#] Diagram 13:
   !------#[ Diagram 18:
      if (tens_rec_by_derivatives) then
         call reconstruct_d18(coeffs)
      else
         call reconstruct2(numerator_d18, coeffs%coeffs_18)
      end if
   !------#] Diagram 18:
   !------#[ Diagram 53:
      if (tens_rec_by_derivatives) then
         call reconstruct_d53(coeffs)
      else
         call reconstruct1(numerator_d53, coeffs%coeffs_53)
      end if
   !------#] Diagram 53:
   !------#[ Diagram 57:
      if (tens_rec_by_derivatives) then
         call reconstruct_d57(coeffs)
      else
         call reconstruct3(numerator_d57, coeffs%coeffs_57)
      end if
   !------#] Diagram 57:
   !------#[ Diagram 60:
      if (tens_rec_by_derivatives) then
         call reconstruct_d60(coeffs)
      else
         call reconstruct2(numerator_d60, coeffs%coeffs_60)
      end if
   !------#] Diagram 60:
end subroutine reconstruct_group6
!---#] subroutine reconstruct_group6:
!---#[ subroutine reconstruct_group7:
subroutine     reconstruct_group7(coeffs)
   use tens_rec
   use p7_udbar_neepuubar_config
   use p7_udbar_neepuubar_groups, only: tensrec_info_group7
   use p7_udbar_neepuubar_d1h1l1, only: numerator_d1 => numerator_golem95
   use p7_udbar_neepuubar_d1h1l1d, only: reconstruct_d1
   use p7_udbar_neepuubar_d6h1l1, only: numerator_d6 => numerator_golem95
   use p7_udbar_neepuubar_d6h1l1d, only: reconstruct_d6
   use p7_udbar_neepuubar_d7h1l1, only: numerator_d7 => numerator_golem95
   use p7_udbar_neepuubar_d7h1l1d, only: reconstruct_d7
   use p7_udbar_neepuubar_d8h1l1, only: numerator_d8 => numerator_golem95
   use p7_udbar_neepuubar_d8h1l1d, only: reconstruct_d8
   use p7_udbar_neepuubar_d9h1l1, only: numerator_d9 => numerator_golem95
   use p7_udbar_neepuubar_d9h1l1d, only: reconstruct_d9
   use p7_udbar_neepuubar_d11h1l1, only: numerator_d11 => numerator_golem95
   use p7_udbar_neepuubar_d11h1l1d, only: reconstruct_d11
   use p7_udbar_neepuubar_d15h1l1, only: numerator_d15 => numerator_golem95
   use p7_udbar_neepuubar_d15h1l1d, only: reconstruct_d15
   use p7_udbar_neepuubar_d19h1l1, only: numerator_d19 => numerator_golem95
   use p7_udbar_neepuubar_d19h1l1d, only: reconstruct_d19
   use p7_udbar_neepuubar_d35h1l1, only: numerator_d35 => numerator_golem95
   use p7_udbar_neepuubar_d35h1l1d, only: reconstruct_d35
   use p7_udbar_neepuubar_d51h1l1, only: numerator_d51 => numerator_golem95
   use p7_udbar_neepuubar_d51h1l1d, only: reconstruct_d51
   use p7_udbar_neepuubar_d52h1l1, only: numerator_d52 => numerator_golem95
   use p7_udbar_neepuubar_d52h1l1d, only: reconstruct_d52
   use p7_udbar_neepuubar_d54h1l1, only: numerator_d54 => numerator_golem95
   use p7_udbar_neepuubar_d54h1l1d, only: reconstruct_d54
   use p7_udbar_neepuubar_d55h1l1, only: numerator_d55 => numerator_golem95
   use p7_udbar_neepuubar_d55h1l1d, only: reconstruct_d55
   use p7_udbar_neepuubar_d62h1l1, only: numerator_d62 => numerator_golem95
   use p7_udbar_neepuubar_d62h1l1d, only: reconstruct_d62
   use p7_udbar_neepuubar_d65h1l1, only: numerator_d65 => numerator_golem95
   use p7_udbar_neepuubar_d65h1l1d, only: reconstruct_d65
   use p7_udbar_neepuubar_d67h1l1, only: numerator_d67 => numerator_golem95
   use p7_udbar_neepuubar_d67h1l1d, only: reconstruct_d67
   use p7_udbar_neepuubar_d71h1l1, only: numerator_d71 => numerator_golem95
   use p7_udbar_neepuubar_d71h1l1d, only: reconstruct_d71
   implicit none
   type(tensrec_info_group7), intent(out) :: coeffs
   !------#[ Diagram 1:
      if (tens_rec_by_derivatives) then
         call reconstruct_d1(coeffs)
      else
         call reconstruct3(numerator_d1, coeffs%coeffs_1)
      end if
   !------#] Diagram 1:
   !------#[ Diagram 6:
      if (tens_rec_by_derivatives) then
         call reconstruct_d6(coeffs)
      else
         call reconstruct3(numerator_d6, coeffs%coeffs_6)
      end if
   !------#] Diagram 6:
   !------#[ Diagram 7:
      if (tens_rec_by_derivatives) then
         call reconstruct_d7(coeffs)
      else
         call reconstruct2(numerator_d7, coeffs%coeffs_7)
      end if
   !------#] Diagram 7:
   !------#[ Diagram 8:
      if (tens_rec_by_derivatives) then
         call reconstruct_d8(coeffs)
      else
         call reconstruct2(numerator_d8, coeffs%coeffs_8)
      end if
   !------#] Diagram 8:
   !------#[ Diagram 9:
      if (tens_rec_by_derivatives) then
         call reconstruct_d9(coeffs)
      else
         call reconstruct2(numerator_d9, coeffs%coeffs_9)
      end if
   !------#] Diagram 9:
   !------#[ Diagram 11:
      if (tens_rec_by_derivatives) then
         call reconstruct_d11(coeffs)
      else
         call reconstruct2(numerator_d11, coeffs%coeffs_11)
      end if
   !------#] Diagram 11:
   !------#[ Diagram 15:
      if (tens_rec_by_derivatives) then
         call reconstruct_d15(coeffs)
      else
         call reconstruct2(numerator_d15, coeffs%coeffs_15)
      end if
   !------#] Diagram 15:
   !------#[ Diagram 19:
      if (tens_rec_by_derivatives) then
         call reconstruct_d19(coeffs)
      else
         call reconstruct2(numerator_d19, coeffs%coeffs_19)
      end if
   !------#] Diagram 19:
   !------#[ Diagram 35:
      if (tens_rec_by_derivatives) then
         call reconstruct_d35(coeffs)
      else
         call reconstruct2(numerator_d35, coeffs%coeffs_35)
      end if
   !------#] Diagram 35:
   !------#[ Diagram 51:
      if (tens_rec_by_derivatives) then
         call reconstruct_d51(coeffs)
      else
         call reconstruct1(numerator_d51, coeffs%coeffs_51)
      end if
   !------#] Diagram 51:
   !------#[ Diagram 52:
      if (tens_rec_by_derivatives) then
         call reconstruct_d52(coeffs)
      else
         call reconstruct1(numerator_d52, coeffs%coeffs_52)
      end if
   !------#] Diagram 52:
   !------#[ Diagram 54:
      if (tens_rec_by_derivatives) then
         call reconstruct_d54(coeffs)
      else
         call reconstruct1(numerator_d54, coeffs%coeffs_54)
      end if
   !------#] Diagram 54:
   !------#[ Diagram 55:
      if (tens_rec_by_derivatives) then
         call reconstruct_d55(coeffs)
      else
         call reconstruct3(numerator_d55, coeffs%coeffs_55)
      end if
   !------#] Diagram 55:
   !------#[ Diagram 62:
      if (tens_rec_by_derivatives) then
         call reconstruct_d62(coeffs)
      else
         call reconstruct2(numerator_d62, coeffs%coeffs_62)
      end if
   !------#] Diagram 62:
   !------#[ Diagram 65:
      if (tens_rec_by_derivatives) then
         call reconstruct_d65(coeffs)
      else
         call reconstruct2(numerator_d65, coeffs%coeffs_65)
      end if
   !------#] Diagram 65:
   !------#[ Diagram 67:
      if (tens_rec_by_derivatives) then
         call reconstruct_d67(coeffs)
      else
         call reconstruct2(numerator_d67, coeffs%coeffs_67)
      end if
   !------#] Diagram 67:
   !------#[ Diagram 71:
      if (tens_rec_by_derivatives) then
         call reconstruct_d71(coeffs)
      else
         call reconstruct2(numerator_d71, coeffs%coeffs_71)
      end if
   !------#] Diagram 71:
end subroutine reconstruct_group7
!---#] subroutine reconstruct_group7:
end module p7_udbar_neepuubar_golem95h1
