module     p8_udbar_neepssbar_d32h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p8_udbar_neepssbar/helicity0/d32h0l1d.f90
   ! generator: haggies (1.1)
   use p8_udbar_neepssbar_config, only: ki
   use p8_udbar_neepssbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d32
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p8_udbar_neepssbar_globalsl1, only: epspow
      use p8_udbar_neepssbar_kinematics
      use p8_udbar_neepssbar_abbrevd32h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k6+k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t2 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t3 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t4 = (spvak3k5(1)*qshift(1)-spvak3k5(2)*qshift(2)-spvak3k5(3)*qshift(3)-sp&
      &vak3k5(4)*qshift(4))
      t5 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t6 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb32n11+t1*abb32n20+t2*abb32n21+t3*abb32n22+abb32n23*dotp&
         &roduct(k5, qshift)+t1*t4*abb32n12+t1*t6*abb32n15+t2*t5*abb32n14+t3*t5*&
         &abb32n13)
         return
      end if
      t7 = spvak2k1(iv1)
      t8 = spvak3k1(iv1)
      t9 = spvak6k1(iv1)
      t10 = spvak2k5(iv1)
      t11 = spvak3k5(iv1)
      t12 = spvak6k5(iv1)
      if(deg.eq.1) then
         numerator = (k5(iv1)*abb32n16+t7*abb32n18+t8*abb32n17+t9*abb32n19+t1*t1&
         &0*abb32n24+t1*t11*abb32n27+t12*t2*abb32n25+t12*t3*abb32n26+t4*t9*abb32&
         &n27+t5*t7*abb32n25+t5*t8*abb32n26+t6*t9*abb32n24)
         return
      end if
      t1 = spvak6k5(iv2)
      t2 = spvak6k1(iv2)
      if(deg.eq.2) then
         numerator = (spvak2k1(iv2)*t12*abb32n14+spvak2k5(iv2)*t9*abb32n15+spvak&
         &3k1(iv2)*t12*abb32n13+spvak3k5(iv2)*t9*abb32n12+t1*t7*abb32n14+t1*t8*a&
         &bb32n13+t10*t2*abb32n15+t11*t2*abb32n12)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d32:
   subroutine     reconstruct_d32(coeffs)
      use p8_udbar_neepssbar_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_32:
      coeffs%coeffs_32%c0 = derivative(czip)
      coeffs%coeffs_32%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_32%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_32%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_32%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_32%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_32%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_32%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_32%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_32%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_32%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_32%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_32%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_32%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_32%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_32:
   end subroutine reconstruct_d32
!---#] subroutine reconstruct_d32:
end module p8_udbar_neepssbar_d32h0l1d
