module     p8_udbar_neepssbar_d33h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p8_udbar_neepssbar/helicity0/d33h0l1d.f90
   ! generator: haggies (1.1)
   use p8_udbar_neepssbar_config, only: ki
   use p8_udbar_neepssbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d33
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p8_udbar_neepssbar_globalsl1, only: epspow
      use p8_udbar_neepssbar_kinematics
      use p8_udbar_neepssbar_abbrevd33h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k6+k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t2 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t3 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb33n7+abb33n12*dotproduct(k1, qshift)+abb33n12*dotproduc&
         &t(k6, qshift)+abb33n14*(spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-sp&
         &vak6k1(3)*qshift(3)-spvak6k1(4)*qshift(4))+t1*t2*abb33n10+t2*t3*abb33n&
         &8)
         return
      end if
      t4 = spvak2k1(iv1)
      t5 = spvak3k1(iv1)
      t6 = spvak6k5(iv1)
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb33n11+k6(iv1)*abb33n11+spvak6k1(iv1)*abb33n9+t1&
         &*t6*abb33n13+t2*t4*abb33n13+t2*t5*abb33n15+t3*t6*abb33n15)
         return
      end if
      t1 = spvak6k5(iv2)
      if(deg.eq.2) then
         numerator = (spvak2k1(iv2)*t6*abb33n10+spvak3k1(iv2)*t6*abb33n8+t1*t4*a&
         &bb33n10+t1*t5*abb33n8)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d33:
   subroutine     reconstruct_d33(coeffs)
      use p8_udbar_neepssbar_groups, only: tensrec_info_group3
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group3), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_33:
      coeffs%coeffs_33%c0 = derivative(czip)
      coeffs%coeffs_33%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_33%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_33%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_33%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_33%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_33%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_33%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_33%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_33%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_33%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_33%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_33%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_33%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_33%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_33:
   end subroutine reconstruct_d33
!---#] subroutine reconstruct_d33:
end module p8_udbar_neepssbar_d33h0l1d
