module     p8_udbar_neepssbar_d14h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p8_udbar_neepssbar/helicity1/d14h1l1d.f90
   ! generator: haggies (1.1)
   use p8_udbar_neepssbar_config, only: ki
   use p8_udbar_neepssbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d14
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p8_udbar_neepssbar_globalsl1, only: epspow
      use p8_udbar_neepssbar_kinematics
      use p8_udbar_neepssbar_abbrevd14h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k6+k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t2 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t3 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t4 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb14n14+t1*abb14n30+abb14n21*dotproduct(qshift, qshift)+a&
         &bb14n25*(spvak5k4(1)*qshift(1)-spvak5k4(2)*qshift(2)-spvak5k4(3)*qshif&
         &t(3)-spvak5k4(4)*qshift(4))+abb14n27*(spvak2k6(1)*qshift(1)-spvak2k6(2&
         &)*qshift(2)-spvak2k6(3)*qshift(3)-spvak2k6(4)*qshift(4))+abb14n29*dotp&
         &roduct(k5, qshift)+abb14n29*dotproduct(k6, qshift)+abb14n31*(spvak3k6(&
         &1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-spvak3k6(4)*q&
         &shift(4))+abb14n33*(spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5&
         &k1(3)*qshift(3)-spvak5k1(4)*qshift(4))+t1*t2*abb14n15+t1*t3*abb14n17+t&
         &1*t4*abb14n23)
         return
      end if
      t5 = spvak5k6(iv1)
      t6 = spvak2k1(iv1)
      t7 = spvak2k4(iv1)
      t8 = spvak3k1(iv1)
      if(deg.eq.1) then
         numerator = (k5(iv1)*abb14n20+k6(iv1)*abb14n20+qshift(iv1)*abb14n28+spv&
         &ak2k6(iv1)*abb14n22+spvak3k6(iv1)*abb14n18+spvak5k1(iv1)*abb14n16+spva&
         &k5k4(iv1)*abb14n24+t5*abb14n19+t1*t6*abb14n32+t1*t7*abb14n26+t1*t8*abb&
         &14n34+t2*t5*abb14n34+t3*t5*abb14n32+t4*t5*abb14n26)
         return
      end if
      t1 = spvak5k6(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb14n21+spvak2k1(iv2)*t5*abb14n17+spv&
         &ak2k4(iv2)*t5*abb14n23+spvak3k1(iv2)*t5*abb14n15+t1*t6*abb14n17+t1*t7*&
         &abb14n23+t1*t8*abb14n15)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d14:
   subroutine     reconstruct_d14(coeffs)
      use p8_udbar_neepssbar_groups, only: tensrec_info_group0
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group0), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_14:
      coeffs%coeffs_14%c0 = derivative(czip)
      coeffs%coeffs_14%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_14%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_14%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_14%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_14%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_14%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_14%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_14%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_14%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_14%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_14%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_14%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_14%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_14%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_14:
   end subroutine reconstruct_d14
!---#] subroutine reconstruct_d14:
end module p8_udbar_neepssbar_d14h1l1d
