module     p8_udbar_neepssbar_d2h1l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p8_udbar_neepssbar/helicity1/d2h1l1.f90
   ! generator: haggies (1.1)
   use p8_udbar_neepssbar_config, only: ki
   use p8_udbar_neepssbar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p8_udbar_neepssbar_groups, only: &
!           & sign => diagram2_sign, shift => diagram2_shift
      use p8_udbar_neepssbar_globalsl1, only: epspow
      use p8_udbar_neepssbar_kinematics
      use p8_udbar_neepssbar_abbrevd2h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d2
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k2
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d2 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*spvak4k1(1)-Q(2)*spvak4k1(2)-Q(3)*spvak4k1(3)-Q(4)*spvak4k1(4))
      t5 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t6 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t7 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t8 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t9 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t10 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t11 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t12 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      d2 = (abb2n1+t1*abb2n10+t2*abb2n16+t3*abb2n17+t4*abb2n19+t5*abb2n2+t6*abb2&
      &n3+t7*abb2n3+t8*abb2n4+t9*abb2n6+t1*t8*abb2n18+t10*t2*abb2n12+t10*t3*abb2&
      &n13+t10*t6*abb2n14+t10*t7*abb2n14+t10*t8*abb2n15+t11*t2*abb2n22+t11*t3*ab&
      &b2n21+t11*t6*abb2n20+t11*t7*abb2n20+t11*t8*abb2n23+t12*t5*abb2n7+t12*t8*a&
      &bb2n24+t2*t5*abb2n9+t2*t8*abb2n18+t2*t9*abb2n26+t3*t5*abb2n8+t3*t9*abb2n2&
      &8+t4*t8*abb2n27+t5*t9*abb2n5+t5*abb2n11*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2&
      &)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))+t6*t9*abb2n29+t7*t9*abb2n29+t8*t9*ab&
      &b2n25+t12*t5*t8*abb2n30)
      numerator = cmplx(real(d2, ki), aimag(d2), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p8_udbar_neepssbar_globalsl1, only: epspow
      use p8_udbar_neepssbar_kinematics
      use p8_udbar_neepssbar_abbrevd2h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d2
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k2
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d2 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*spvak4k1(1)-Q(2)*spvak4k1(2)-Q(3)*spvak4k1(3)-Q(4)*spvak4k1(4))
      t5 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t6 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t7 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t8 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t9 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t10 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t11 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t12 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      d2 = (abb2n1+t1*abb2n10+t2*abb2n16+t3*abb2n17+t4*abb2n19+t5*abb2n2+t6*abb2&
      &n3+t7*abb2n3+t8*abb2n4+t9*abb2n6+t1*t8*abb2n18+t10*t2*abb2n12+t10*t3*abb2&
      &n13+t10*t6*abb2n14+t10*t7*abb2n14+t10*t8*abb2n15+t11*t2*abb2n22+t11*t3*ab&
      &b2n21+t11*t6*abb2n20+t11*t7*abb2n20+t11*t8*abb2n23+t12*t5*abb2n7+t12*t8*a&
      &bb2n24+t2*t5*abb2n9+t2*t8*abb2n18+t2*t9*abb2n26+t3*t5*abb2n8+t3*t9*abb2n2&
      &8+t4*t8*abb2n27+t5*t9*abb2n5+t5*abb2n11*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2&
      &)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))+t6*t9*abb2n29+t7*t9*abb2n29+t8*t9*ab&
      &b2n25+t12*t5*t8*abb2n30)

      numerator = cmplx(real(d2, ki), aimag(d2), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p8_udbar_neepssbar_d2h1l1
