module     p9_udbar_neepgg_d23h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity0/d23h0l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d23
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd23h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      real(ki) :: t27
      real(ki) :: t28
      real(ki) :: t29
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(deg.eq.0) then
         numerator = (0.0_ki)
         return
      end if
      t1 = k1(iv1)
      t2 = k2(iv1)
      t3 = k5(iv1)
      t4 = k6(iv1)
      t5 = spvak2k5(iv1)
      t6 = spvak3k4(iv1)
      t7 = spvak5k1(iv1)
      t8 = spvak5k6(iv1)
      t9 = spvak6k5(iv1)
      if(deg.eq.1) then
         numerator = (t1*abb23n68+t2*abb23n72+t3*abb23n70+t4*abb23n67+t5*abb23n5&
         &8+t6*abb23n73+t7*abb23n66+t8*abb23n59+t9*abb23n38)
         return
      end if
      t27 = d(iv1,iv2)
      t10 = k5(iv2)
      t11 = spvak6k5(iv2)
      t12 = k1(iv2)
      t13 = k6(iv2)
      t14 = spvak2k5(iv2)
      t15 = spvak5k1(iv2)
      t16 = spvak5k6(iv2)
      t17 = spvak3k4(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*t27*abb23n71+k2(iv2)*t9*abb23n56+spvak2k4(iv1)*t1&
         &1*abb23n57+spvak2k4(iv2)*t9*abb23n57+t1*t10*abb23n49+t1*t11*abb23n47+t&
         &10*t4*abb23n52+t10*t5*abb23n41+t10*t7*abb23n63+t10*t8*abb23n45+t11*t2*&
         &abb23n56+t11*t4*abb23n48+t11*t5*abb23n42+t11*t6*abb23n62+t11*t7*abb23n&
         &61+t11*t8*abb23n44+t12*t3*abb23n49+t12*t9*abb23n47+t13*t3*abb23n52+t13&
         &*t9*abb23n48+t14*t3*abb23n41+t14*t6*abb23n69+t14*t9*abb23n42+t15*t3*ab&
         &b23n63+t15*t9*abb23n61+t16*t3*abb23n45+t16*t9*abb23n44+t17*t5*abb23n69&
         &+t17*t9*abb23n62)
         return
      end if
      t28 = d(iv2,iv3)
      t29 = d(iv1,iv3)
      t2 = k1(iv3)
      t3 = k6(iv3)
      t10 = spvak5k1(iv3)
      t18 = spvak5k6(iv3)
      t19 = spvak6k5(iv3)
      t20 = spvak3k4(iv3)
      t21 = spvak2k1(iv1)
      t22 = spvak2k1(iv2)
      t23 = spvak2k1(iv3)
      t24 = spvak2k6(iv1)
      t25 = spvak2k6(iv2)
      t26 = spvak2k6(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak2k5(iv3)*t27*abb23n40+t1*t28*abb23n51+t10*t&
         &27*abb23n64+t11*t29*abb23n55+t12*t29*abb23n51+t13*t29*abb23n50+t14*t29&
         &*abb23n40+t15*t29*abb23n64+t16*t29*abb23n46+t18*t27*abb23n46+t19*t27*a&
         &bb23n55+t2*t27*abb23n51+t27*t3*abb23n50+t28*t4*abb23n50+t28*t5*abb23n4&
         &0+t28*t7*abb23n64+t28*t8*abb23n46+t28*t9*abb23n55)+t1*t11*t20*abb23n53&
         &+t1*t17*t19*abb23n53+t10*t11*t6*abb23n65+t10*t17*t9*abb23n65+t11*t18*t&
         &6*abb23n43+t11*t2*t6*abb23n53+t11*t20*t21*abb23n60+t11*t20*t24*abb23n3&
         &9+t11*t20*t4*abb23n54+t11*t20*t7*abb23n65+t11*t20*t8*abb23n43+t11*t23*&
         &t6*abb23n60+t11*t26*t6*abb23n39+t11*t3*t6*abb23n54+t12*t19*t6*abb23n53&
         &+t12*t20*t9*abb23n53+t13*t19*t6*abb23n54+t13*t20*t9*abb23n54+t15*t19*t&
         &6*abb23n65+t15*t20*t9*abb23n65+t16*t19*t6*abb23n43+t16*t20*t9*abb23n43&
         &+t17*t18*t9*abb23n43+t17*t19*t21*abb23n60+t17*t19*t24*abb23n39+t17*t19&
         &*t4*abb23n54+t17*t19*t7*abb23n65+t17*t19*t8*abb23n43+t17*t2*t9*abb23n5&
         &3+t17*t23*t9*abb23n60+t17*t26*t9*abb23n39+t17*t3*t9*abb23n54+t19*t22*t&
         &6*abb23n60+t19*t25*t6*abb23n39+t20*t22*t9*abb23n60+t20*t25*t9*abb23n39&
         &)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d23:
   subroutine     reconstruct_d23(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group6
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group6), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_23:
      coeffs%coeffs_23%c0 = derivative(czip)
      coeffs%coeffs_23%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_23%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_23%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_23%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_23%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_23%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_23%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_23%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_23%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_23%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_23%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_23%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_23%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_23%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_23%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_23%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_23%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_23%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_23%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_23%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_23%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_23%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_23%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_23%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_23%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_23%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_23%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_23%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_23%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_23%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_23%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_23%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_23%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_23%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_23:
   end subroutine reconstruct_d23
!---#] subroutine reconstruct_d23:
end module p9_udbar_neepgg_d23h0l1d
