module     p9_udbar_neepgg_d24h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity0/d24h0l1.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p9_udbar_neepgg_groups, only: &
!           & sign => diagram24_sign, shift => diagram24_shift
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd24h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d24
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(-Q_ext(4),   ki_sam), aimag(-Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3), ki_sam), aimag(-Q_ext(1:3)), ki)
      d24 = 0.0_ki
      t1 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t2 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t3 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t4 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t5 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t6 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t7 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t8 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t9 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      d24 = (abb24n1+t1*abb24n17+t2*abb24n19+t3*abb24n2+t4*abb24n20+t5*abb24n21+&
      &t5*t5*abb24n36+t6*abb24n22+t7*abb24n23+t7*t7*abb24n36+t8*abb24n24+t9*abb2&
      &4n4+t1*t2*abb24n16+t1*t3*abb24n9+t1*t5*abb24n11+t1*t6*abb24n12+t1*t7*abb2&
      &4n13+t1*t8*abb24n11+t1*t9*abb24n8+t2*t3*abb24n14+t2*t4*abb24n42+t2*t5*abb&
      &24n37+t2*t6*abb24n27+t2*t7*abb24n38+t2*t8*abb24n29+t2*t9*abb24n28+t2*abb2&
      &4n15*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)+t3*t4*abb24n3+t3*t5*abb24n7+t3*t6*abb24n6+t3*t7*abb24n5+t3*t8*abb24n5+t&
      &4*t5*abb24n39+t4*t6*abb24n40+t4*t7*abb24n41+t4*t8*abb24n39+t5*t6*abb24n35&
      &+t5*t7*abb24n32+t5*t8*abb24n36+t5*t9*abb24n26+t6*t7*abb24n34+t7*t8*abb24n&
      &33+t7*t9*abb24n25+t1*t2*t3*abb24n10+t2*t3*t4*abb24n43+t2*t3*t5*abb24n30+t&
      &2*t3*t7*abb24n31+t2*t3*abb24n18*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*s&
      &pvak2k1(3)-Q(4)*spvak2k1(4))+t2*t3*abb24n44*(Q(1)*spvak2k6(1)-Q(2)*spvak2&
      &k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)))
      numerator = cmplx(real(d24, ki), aimag(d24), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd24h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d24
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(-Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d24 = 0.0_ki
      t1 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t2 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t3 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t4 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t5 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t6 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t7 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t8 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t9 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      d24 = (abb24n1+t1*abb24n17+t2*abb24n19+t3*abb24n2+t4*abb24n20+t5*abb24n21+&
      &t5*t5*abb24n36+t6*abb24n22+t7*abb24n23+t7*t7*abb24n36+t8*abb24n24+t9*abb2&
      &4n4+t1*t2*abb24n16+t1*t3*abb24n9+t1*t5*abb24n11+t1*t6*abb24n12+t1*t7*abb2&
      &4n13+t1*t8*abb24n11+t1*t9*abb24n8+t2*t3*abb24n14+t2*t4*abb24n42+t2*t5*abb&
      &24n37+t2*t6*abb24n27+t2*t7*abb24n38+t2*t8*abb24n29+t2*t9*abb24n28+t2*abb2&
      &4n15*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)+t3*t4*abb24n3+t3*t5*abb24n7+t3*t6*abb24n6+t3*t7*abb24n5+t3*t8*abb24n5+t&
      &4*t5*abb24n39+t4*t6*abb24n40+t4*t7*abb24n41+t4*t8*abb24n39+t5*t6*abb24n35&
      &+t5*t7*abb24n32+t5*t8*abb24n36+t5*t9*abb24n26+t6*t7*abb24n34+t7*t8*abb24n&
      &33+t7*t9*abb24n25+t1*t2*t3*abb24n10+t2*t3*t4*abb24n43+t2*t3*t5*abb24n30+t&
      &2*t3*t7*abb24n31+t2*t3*abb24n18*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*s&
      &pvak2k1(3)-Q(4)*spvak2k1(4))+t2*t3*abb24n44*(Q(1)*spvak2k6(1)-Q(2)*spvak2&
      &k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)))

      numerator = cmplx(real(d24, ki), aimag(d24), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p9_udbar_neepgg_d24h0l1
