module     p9_udbar_neepgg_d84h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity0/d84h0l1.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p9_udbar_neepgg_groups, only: &
!           & sign => diagram84_sign, shift => diagram84_shift
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd84h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d84
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k2
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d84 = 0.0_ki
      t1 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t2 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t3 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t4 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t5 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t6 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t7 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))
      t8 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t9 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t10 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t11 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4)&
      &)
      t12 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t13 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      t14 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      d84 = (abb84n1+t1*abb84n13+t10*abb84n7+t2*abb84n14+t3*abb84n15+t4*abb84n16&
      &+t5*abb84n17+t6*abb84n23+t6*t6*abb84n35+t7*abb84n3+t8*abb84n39+t9*abb84n4&
      &+t1*t10*abb84n62+t1*t11*abb84n48+t1*t13*abb84n71+t1*t3*abb84n25+t1*t4*abb&
      &84n33+t1*t5*abb84n26+t1*t6*abb84n27+t1*t8*abb84n45+t1*t9*abb84n21+t10*t2*&
      &abb84n60+t10*t3*abb84n83+t10*t5*abb84n86+t10*t6*abb84n85+t10*t8*abb84n84+&
      &t10*t9*abb84n5+t11*t2*abb84n47+t11*t3*abb84n49+t11*t4*abb84n53+t11*t5*abb&
      &84n54+t11*t6*abb84n55+t11*t8*abb84n56+t11*t9*abb84n20+t12*t4*abb84n59+t13&
      &*t2*abb84n73+t13*t4*abb84n74+t13*t6*abb84n72+t2*t3*abb84n10+t2*t8*abb84n4&
      &3+t3*t4*abb84n11+t3*t6*abb84n34+t3*t7*abb84n75+t3*t8*abb84n40+t3*t9*abb84&
      &n18+t4*t5*abb84n9+t4*t6*abb84n8+t4*t7*abb84n61+t4*t8*abb84n46+t4*t9*abb84&
      &n12+t5*t6*abb84n36+t5*t7*abb84n76+t6*t7*abb84n77+t6*t8*abb84n44+t6*t9*abb&
      &84n22+t7*t8*abb84n78+t7*t9*abb84n2+t8*t9*abb84n6+t1*t10*t3*abb84n70+t1*t1&
      &3*t3*abb84n79+t1*t14*t3*abb84n52+t1*t3*t4*abb84n24+t1*t3*t9*abb84n42+t10*&
      &t2*t3*abb84n67+t10*t3*t4*abb84n65+t10*t3*t6*abb84n68+t10*t3*t9*abb84n19+t&
      &11*t3*t4*abb84n28+t11*t4*t5*abb84n29+t11*t4*t6*abb84n30+t11*t4*t8*abb84n3&
      &1+t11*t4*t9*abb84n38+t12*t3*t4*abb84n63+t12*t3*t9*abb84n32+t12*t4*t9*abb8&
      &4n82+t13*t2*t3*abb84n81+t13*t3*t4*abb84n90+t13*t3*t6*abb84n80+t13*t4*t5*a&
      &bb84n87+t13*t4*t6*abb84n88+t13*t4*t8*abb84n89+t14*t2*t3*abb84n50+t14*t3*t&
      &4*abb84n57+t14*t3*t6*abb84n51+t3*t4*t7*abb84n69+t3*t4*t8*abb84n24+t3*t6*t&
      &9*abb84n41+t3*t9*abb84n58*(Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k&
      &6(3)-Q(4)*spvak2k6(4))+t4*t5*t7*abb84n66+t4*t6*t7*abb84n65+t4*t7*t8*abb84&
      &n64+t4*t8*t9*abb84n37+t12*t3*t4*t9*abb84n91)
      numerator = cmplx(real(d84, ki), aimag(d84), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd84h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d84
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k2
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d84 = 0.0_ki
      t1 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t2 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t3 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t4 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t5 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t6 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t7 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))
      t8 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t9 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t10 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t11 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4)&
      &)
      t12 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t13 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      t14 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      d84 = (abb84n1+t1*abb84n13+t10*abb84n7+t2*abb84n14+t3*abb84n15+t4*abb84n16&
      &+t5*abb84n17+t6*abb84n23+t6*t6*abb84n35+t7*abb84n3+t8*abb84n39+t9*abb84n4&
      &+t1*t10*abb84n62+t1*t11*abb84n48+t1*t13*abb84n71+t1*t3*abb84n25+t1*t4*abb&
      &84n33+t1*t5*abb84n26+t1*t6*abb84n27+t1*t8*abb84n45+t1*t9*abb84n21+t10*t2*&
      &abb84n60+t10*t3*abb84n83+t10*t5*abb84n86+t10*t6*abb84n85+t10*t8*abb84n84+&
      &t10*t9*abb84n5+t11*t2*abb84n47+t11*t3*abb84n49+t11*t4*abb84n53+t11*t5*abb&
      &84n54+t11*t6*abb84n55+t11*t8*abb84n56+t11*t9*abb84n20+t12*t4*abb84n59+t13&
      &*t2*abb84n73+t13*t4*abb84n74+t13*t6*abb84n72+t2*t3*abb84n10+t2*t8*abb84n4&
      &3+t3*t4*abb84n11+t3*t6*abb84n34+t3*t7*abb84n75+t3*t8*abb84n40+t3*t9*abb84&
      &n18+t4*t5*abb84n9+t4*t6*abb84n8+t4*t7*abb84n61+t4*t8*abb84n46+t4*t9*abb84&
      &n12+t5*t6*abb84n36+t5*t7*abb84n76+t6*t7*abb84n77+t6*t8*abb84n44+t6*t9*abb&
      &84n22+t7*t8*abb84n78+t7*t9*abb84n2+t8*t9*abb84n6+t1*t10*t3*abb84n70+t1*t1&
      &3*t3*abb84n79+t1*t14*t3*abb84n52+t1*t3*t4*abb84n24+t1*t3*t9*abb84n42+t10*&
      &t2*t3*abb84n67+t10*t3*t4*abb84n65+t10*t3*t6*abb84n68+t10*t3*t9*abb84n19+t&
      &11*t3*t4*abb84n28+t11*t4*t5*abb84n29+t11*t4*t6*abb84n30+t11*t4*t8*abb84n3&
      &1+t11*t4*t9*abb84n38+t12*t3*t4*abb84n63+t12*t3*t9*abb84n32+t12*t4*t9*abb8&
      &4n82+t13*t2*t3*abb84n81+t13*t3*t4*abb84n90+t13*t3*t6*abb84n80+t13*t4*t5*a&
      &bb84n87+t13*t4*t6*abb84n88+t13*t4*t8*abb84n89+t14*t2*t3*abb84n50+t14*t3*t&
      &4*abb84n57+t14*t3*t6*abb84n51+t3*t4*t7*abb84n69+t3*t4*t8*abb84n24+t3*t6*t&
      &9*abb84n41+t3*t9*abb84n58*(Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k&
      &6(3)-Q(4)*spvak2k6(4))+t4*t5*t7*abb84n66+t4*t6*t7*abb84n65+t4*t7*t8*abb84&
      &n64+t4*t8*t9*abb84n37+t12*t3*t4*t9*abb84n91)

      numerator = cmplx(real(d84, ki), aimag(d84), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p9_udbar_neepgg_d84h0l1
