module     p9_udbar_neepgg_abbrevd2h1
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_globalsh1
   implicit none
   private
   complex(ki), public :: abb2n1
   complex(ki), public :: rat2d2
   complex(ki), public :: abb2n3
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   real(ki) :: t5
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p9_udbar_neepgg_config, only: deltaOS
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_model
      use p9_udbar_neepgg_color, only: TR
      use p9_udbar_neepgg_globalsl1, only: epspow
      implicit none
      t1 = TR*c3*i_
      t2 = (es34+es56-(es234+es12))*(es34+wW*mW*i_-mW*mW)*spak5k6*spbk6k5
      t5 = NC*TR
      t3 = t5*c1*i_
      t4 = t5*c2*i_
      abb2n1 = ((4.0_ki)*(-(t1/t2*spak2k5*spak3k4*spbk4k1*spbk6k4+t1/t2*spak1k3*&
      &spak2k5*spbk4k1*spbk6k1))+(2.0_ki)*(-(t4/t2*spak2k5*spak3k4*spbk4k1*spbk6&
      &k4+t4/t2*spak1k3*spak2k5*spbk4k1*spbk6k1+t3/t2*spak2k5*spak3k4*spbk4k1*sp&
      &bk6k4+t3/t2*spak1k3*spak2k5*spbk4k1*spbk6k1)))
      rat2d2 = 0
      rat2 = rat2 + rat2d2
      abb2n3 = -(abb2n1)
   end subroutine
end module p9_udbar_neepgg_abbrevd2h1
