module     p9_udbar_neepgg_d13h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity1/d13h1l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d13
contains

!---#[ function derivative:
   function derivative(mu2, i1) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd13h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      complex(ki) :: numerator
      complex(ki) :: loc
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(deg.eq.0) then
         numerator = (abb13n12+abb13n22*(spvak3k4(1)*qshift(1)-spvak3k4(2)*qshif&
         &t(2)-spvak3k4(3)*qshift(3)-spvak3k4(4)*qshift(4))+abb13n23*(spvak5k1(1&
         &)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-spvak5k1(4)*qs&
         &hift(4))+abb13n24*(spvak5k2(1)*qshift(1)-spvak5k2(2)*qshift(2)-spvak5k&
         &2(3)*qshift(3)-spvak5k2(4)*qshift(4))+abb13n25*dotproduct(k5, qshift)+&
         &abb13n26*dotproduct(k2, qshift)+abb13n27*dotproduct(k6, qshift)+abb13n&
         &28*dotproduct(k1, qshift)+abb13n29*(spvak5k6(1)*qshift(1)-spvak5k6(2)*&
         &qshift(2)-spvak5k6(3)*qshift(3)-spvak5k6(4)*qshift(4))+abb13n30*(spvak&
         &2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-spvak2k5(&
         &4)*qshift(4)))
         return
      end if
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb13n15+k2(iv1)*abb13n17+k5(iv1)*abb13n18+k6(iv1)&
         &*abb13n16+spvak2k5(iv1)*abb13n13+spvak3k4(iv1)*abb13n21+spvak5k1(iv1)*&
         &abb13n20+spvak5k2(iv1)*abb13n19+spvak5k6(iv1)*abb13n14)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d13:
   subroutine     reconstruct_d13(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 1 case:
      !---[# reconstruct coeffs%coeffs_13:
      coeffs%coeffs_13%c0 = derivative(czip)
      coeffs%coeffs_13%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_13%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_13%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_13%c1(4,1) = -derivative(czip,4)
      !---#] reconstruct coeffs%coeffs_13:
   end subroutine reconstruct_d13
!---#] subroutine reconstruct_d13:
end module p9_udbar_neepgg_d13h1l1d
