module     p9_udbar_neepgg_d23h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity1/d23h1l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d23
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd23h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      real(ki) :: t24
      real(ki) :: t25
      real(ki) :: t26
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(deg.eq.0) then
         numerator = (0.0_ki)
         return
      end if
      t1 = k5(iv1)
      t2 = spvak5k6(iv1)
      if(deg.eq.1) then
         numerator = (t1*abb23n50+t2*abb23n53)
         return
      end if
      t24 = d(iv1,iv2)
      t3 = spvak5k6(iv2)
      t4 = k1(iv1)
      t5 = k5(iv2)
      t6 = k1(iv2)
      t7 = k6(iv2)
      t8 = spvak2k6(iv2)
      t9 = spvak5k1(iv2)
      t10 = k6(iv1)
      t11 = spvak2k6(iv1)
      t12 = spvak5k1(iv1)
      t13 = spvak3k4(iv1)
      t14 = t13*t3
      t15 = spvak3k4(iv2)
      t16 = t15*t2
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t24*abb23n51+t2*t3*abb23n28)+t14*abb23n49+t16*ab&
         &b23n49+k2(iv1)*t3*abb23n43+k2(iv2)*t2*abb23n43+spvak2k4(iv1)*t3*abb23n&
         &44+spvak2k4(iv2)*t2*abb23n44+spvak2k5(iv1)*t3*abb23n30+spvak2k5(iv2)*t&
         &2*abb23n30+t1*t3*abb23n37+t1*t6*abb23n39+t1*t7*abb23n42+t1*t8*abb23n31&
         &+t1*t9*abb23n47+t10*t3*abb23n34+t10*t5*abb23n42+t11*t5*abb23n31+t12*t3&
         &*abb23n48+t12*t5*abb23n47+t2*t5*abb23n37+t2*t6*abb23n33+t2*t7*abb23n34&
         &+t2*t9*abb23n48+t3*t4*abb23n33+t4*t5*abb23n39)
         return
      end if
      t25 = d(iv2,iv3)
      t26 = d(iv1,iv3)
      t1 = k1(iv3)
      t5 = k6(iv3)
      t17 = spvak2k6(iv3)
      t18 = spvak5k1(iv3)
      t19 = spvak5k6(iv3)
      t20 = spvak3k4(iv3)
      t21 = spvak2k1(iv1)
      t22 = spvak2k1(iv2)
      t23 = spvak2k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t1*t24*abb23n41+t10*t25*abb23n40+t11*t25*abb23n3&
         &0+t12*t25*abb23n46+t14*t19*abb23n32+t16*t19*abb23n32+t17*t24*abb23n30+&
         &t18*t24*abb23n46+t19*t24*abb23n38+t2*t25*abb23n38+t24*t5*abb23n40+t25*&
         &t4*abb23n41+t26*t3*abb23n38+t26*t6*abb23n41+t26*t7*abb23n40+t26*t8*abb&
         &23n30+t26*t9*abb23n46+t2*t20*t3*abb23n32)+t1*t13*t3*abb23n35+t1*t15*t2&
         &*abb23n35+t10*t15*t19*abb23n36+t10*t20*t3*abb23n36+t11*t15*t19*abb23n2&
         &9+t11*t20*t3*abb23n29+t12*t15*t19*abb23n52+t12*t20*t3*abb23n52+t13*t17&
         &*t3*abb23n29+t13*t18*t3*abb23n52+t13*t19*t22*abb23n45+t13*t19*t6*abb23&
         &n35+t13*t19*t7*abb23n36+t13*t19*t8*abb23n29+t13*t19*t9*abb23n52+t13*t2&
         &3*t3*abb23n45+t13*t3*t5*abb23n36+t15*t17*t2*abb23n29+t15*t18*t2*abb23n&
         &52+t15*t19*t21*abb23n45+t15*t19*t4*abb23n35+t15*t2*t23*abb23n45+t15*t2&
         &*t5*abb23n36+t2*t20*t22*abb23n45+t2*t20*t6*abb23n35+t2*t20*t7*abb23n36&
         &+t2*t20*t8*abb23n29+t2*t20*t9*abb23n52+t20*t21*t3*abb23n45+t20*t3*t4*a&
         &bb23n35)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d23:
   subroutine     reconstruct_d23(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group6
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group6), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_23:
      coeffs%coeffs_23%c0 = derivative(czip)
      coeffs%coeffs_23%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_23%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_23%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_23%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_23%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_23%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_23%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_23%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_23%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_23%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_23%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_23%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_23%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_23%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_23%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_23%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_23%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_23%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_23%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_23%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_23%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_23%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_23%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_23%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_23%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_23%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_23%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_23%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_23%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_23%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_23%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_23%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_23%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_23%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_23:
   end subroutine reconstruct_d23
!---#] subroutine reconstruct_d23:
end module p9_udbar_neepgg_d23h1l1d
