module     p9_udbar_neepgg_d33h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity1/d33h1l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d33
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd33h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(deg.eq.0) then
         numerator = abb33n24
         return
      end if
      t1 = k1(iv1)
      t2 = k2(iv1)
      t3 = k3(iv1)
      t4 = k4(iv1)
      t5 = k5(iv1)
      t6 = k6(iv1)
      t7 = spvak3k1(iv1)
      t8 = spvak3k4(iv1)
      t9 = spvak5k1(iv1)
      t10 = spvak5k6(iv1)
      if(deg.eq.1) then
         numerator = (t1*abb33n36+t10*abb33n34+t2*abb33n38+t3*abb33n44+t4*abb33n&
         &44+t5*abb33n32+t6*abb33n37+t7*abb33n43+t8*abb33n40+t9*abb33n39)
         return
      end if
      t11 = spvak5k6(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(d(iv1,iv2)*abb33n31+t10*t11*abb33n26)+k1(iv2)*t1&
         &0*abb33n28+k2(iv2)*t10*abb33n30+k3(iv2)*t10*abb33n42+k4(iv2)*t10*abb33&
         &n42+k5(iv2)*t10*abb33n29+k6(iv2)*t10*abb33n27+spvak2k5(iv1)*t11*abb33n&
         &25+spvak2k5(iv2)*t10*abb33n25+spvak3k1(iv2)*t10*abb33n41+spvak3k4(iv2)&
         &*t10*abb33n35+spvak5k1(iv2)*t10*abb33n33+t1*t11*abb33n28+t11*t2*abb33n&
         &30+t11*t3*abb33n42+t11*t4*abb33n42+t11*t5*abb33n29+t11*t6*abb33n27+t11&
         &*t7*abb33n41+t11*t8*abb33n35+t11*t9*abb33n33)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d33:
   subroutine     reconstruct_d33(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_33:
      coeffs%coeffs_33%c0 = derivative(czip)
      coeffs%coeffs_33%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_33%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_33%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_33%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_33%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_33%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_33%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_33%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_33%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_33%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_33%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_33%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_33%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_33%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_33:
   end subroutine reconstruct_d33
!---#] subroutine reconstruct_d33:
end module p9_udbar_neepgg_d33h1l1d
