module     p9_udbar_neepgg_d35h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity1/d35h1l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d35
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd35h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      real(ki) :: t6
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k6-k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t6 = dotproduct(k1, qshift)
      t2 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb35n12+t1*abb35n17+t6*abb35n18+abb35n14*dotproduct(qshif&
         &t, qshift)+abb35n16*(spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak&
         &5k1(3)*qshift(3)-spvak5k1(4)*qshift(4))+abb35n19*dotproduct(k6, qshift&
         &)+abb35n21*(spvak1k6(1)*qshift(1)-spvak1k6(2)*qshift(2)-spvak1k6(3)*qs&
         &hift(3)-spvak1k6(4)*qshift(4))+t1*t2*abb35n15+t1*t6*abb35n13)
         return
      end if
      t3 = k1(iv1)
      t4 = spvak5k6(iv1)
      t5 = spvak6k1(iv1)
      if(deg.eq.1) then
         numerator = (k6(iv1)*abb35n19+qshift(iv1)*abb35n20+spvak1k6(iv1)*abb35n&
         &21+spvak5k1(iv1)*abb35n16+t3*abb35n18+t4*abb35n17+t1*t3*abb35n13+t1*t5&
         &*abb35n15+t2*t4*abb35n15+t4*t6*abb35n13)
         return
      end if
      t1 = spvak5k6(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb35n14+k1(iv2)*t4*abb35n13+spvak6k1(&
         &iv2)*t4*abb35n15+t1*t3*abb35n13+t1*t5*abb35n15)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d35:
   subroutine     reconstruct_d35(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group3
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group3), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_35:
      coeffs%coeffs_35%c0 = derivative(czip)
      coeffs%coeffs_35%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_35%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_35%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_35%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_35%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_35%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_35%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_35%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_35%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_35%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_35%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_35%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_35%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_35%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_35:
   end subroutine reconstruct_d35
!---#] subroutine reconstruct_d35:
end module p9_udbar_neepgg_d35h1l1d
