module     p9_udbar_neepgg_d86h1l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity1/d86h1l1.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p9_udbar_neepgg_groups, only: &
!           & sign => diagram86_sign, shift => diagram86_shift
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd86h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d86
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k5
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d86 = 0.0_ki
      t1 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t2 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t3 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t4 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t5 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t6 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t7 = t2*t2
      t8 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t9 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t10 = t6*abb86n29
      t11 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4)&
      &)
      t12 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t13 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t14 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)&
      &)
      t15 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      d86 = (abb86n1+t1*abb86n10+t10*t4+t10*t5+t2*abb86n11+t3*abb86n2+t4*abb86n2&
      &0+t5*abb86n21+t5*t5*abb86n26+t6*abb86n22+t6*t6*abb86n28+t7*abb86n31+t8*ab&
      &b86n4+t9*abb86n9+t1*t2*abb86n24+t1*t4*abb86n30+t1*t5*abb86n29+t1*t6*abb86&
      &n27+t1*t8*abb86n51+t11*t2*abb86n38+t11*t7*abb86n8+t12*t7*abb86n42+t13*t7*&
      &abb86n44+t14*t2*abb86n52+t14*t7*abb86n47+t15*t7*abb86n60+t2*t3*abb86n3+t2&
      &*t4*abb86n32+t2*t5*abb86n33+t2*t6*abb86n34+t2*t8*abb86n59+t2*t9*abb86n23+&
      &t3*t4*abb86n14+t3*t5*abb86n13+t3*t6*abb86n12+t3*t7*abb86n19+t3*t8*abb86n1&
      &7+t4*t5*abb86n25+t4*t7*abb86n6+t4*t8*abb86n16+t5*t7*abb86n5+t5*t8*abb86n5&
      &4+t6*t7*abb86n7+t6*t8*abb86n53+t7*t8*abb86n45+t7*t9*abb86n6+t8*t9*abb86n1&
      &5+t1*t12*t2*abb86n41+t1*t15*t2*abb86n55+t1*t2*t8*abb86n50+t12*t2*t5*abb86&
      &n39+t12*t2*t6*abb86n40+t13*t2*t3*abb86n18+t13*t3*t7*abb86n61+t15*t2*t5*ab&
      &b86n57+t15*t2*t6*abb86n56+t2*t3*t4*abb86n36+t2*t3*t5*abb86n35+t2*t3*t6*ab&
      &b86n37+t2*t3*t8*abb86n58+t2*t3*abb86n43*(Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2&
      &)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))+t2*t4*t8*abb86n47+t2*t5*t8*abb86n46+&
      &t2*t6*t8*abb86n49+t2*t8*t9*abb86n48)
      numerator = cmplx(real(d86, ki), aimag(d86), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd86h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d86
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k5
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d86 = 0.0_ki
      t1 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t2 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t3 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t4 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t5 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t6 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t7 = t2*t2
      t8 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t9 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t10 = t6*abb86n29
      t11 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4)&
      &)
      t12 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t13 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t14 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)&
      &)
      t15 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      d86 = (abb86n1+t1*abb86n10+t10*t4+t10*t5+t2*abb86n11+t3*abb86n2+t4*abb86n2&
      &0+t5*abb86n21+t5*t5*abb86n26+t6*abb86n22+t6*t6*abb86n28+t7*abb86n31+t8*ab&
      &b86n4+t9*abb86n9+t1*t2*abb86n24+t1*t4*abb86n30+t1*t5*abb86n29+t1*t6*abb86&
      &n27+t1*t8*abb86n51+t11*t2*abb86n38+t11*t7*abb86n8+t12*t7*abb86n42+t13*t7*&
      &abb86n44+t14*t2*abb86n52+t14*t7*abb86n47+t15*t7*abb86n60+t2*t3*abb86n3+t2&
      &*t4*abb86n32+t2*t5*abb86n33+t2*t6*abb86n34+t2*t8*abb86n59+t2*t9*abb86n23+&
      &t3*t4*abb86n14+t3*t5*abb86n13+t3*t6*abb86n12+t3*t7*abb86n19+t3*t8*abb86n1&
      &7+t4*t5*abb86n25+t4*t7*abb86n6+t4*t8*abb86n16+t5*t7*abb86n5+t5*t8*abb86n5&
      &4+t6*t7*abb86n7+t6*t8*abb86n53+t7*t8*abb86n45+t7*t9*abb86n6+t8*t9*abb86n1&
      &5+t1*t12*t2*abb86n41+t1*t15*t2*abb86n55+t1*t2*t8*abb86n50+t12*t2*t5*abb86&
      &n39+t12*t2*t6*abb86n40+t13*t2*t3*abb86n18+t13*t3*t7*abb86n61+t15*t2*t5*ab&
      &b86n57+t15*t2*t6*abb86n56+t2*t3*t4*abb86n36+t2*t3*t5*abb86n35+t2*t3*t6*ab&
      &b86n37+t2*t3*t8*abb86n58+t2*t3*abb86n43*(Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2&
      &)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))+t2*t4*t8*abb86n47+t2*t5*t8*abb86n46+&
      &t2*t6*t8*abb86n49+t2*t8*t9*abb86n48)

      numerator = cmplx(real(d86, ki), aimag(d86), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p9_udbar_neepgg_d86h1l1
