module     p9_udbar_neepgg_d95h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity1/d95h1l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d95
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd95h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(deg.eq.0) then
         numerator = abb95n19
         return
      end if
      t1 = k1(iv1)
      t2 = k2(iv1)
      t3 = k3(iv1)
      t4 = k4(iv1)
      t5 = k5(iv1)
      t6 = spvak3k1(iv1)
      t7 = spvak3k4(iv1)
      t8 = spvak5k6(iv1)
      if(deg.eq.1) then
         numerator = (t1*abb95n31+t2*abb95n32+t3*abb95n30+t4*abb95n30+t5*abb95n3&
         &2+t6*abb95n21+t7*abb95n29+t8*abb95n34)
         return
      end if
      t9 = spvak5k6(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb95n33+k1(iv2)*t8*abb95n24+k2(iv2)*t&
         &8*abb95n26+k3(iv2)*t8*abb95n25+k4(iv2)*t8*abb95n25+k5(iv2)*t8*abb95n27&
         &+k6(iv1)*t9*abb95n27+k6(iv2)*t8*abb95n27+spvak2k1(iv1)*t9*abb95n35+spv&
         &ak2k1(iv2)*t8*abb95n35+spvak2k4(iv1)*t9*abb95n28+spvak2k4(iv2)*t8*abb9&
         &5n28+spvak2k6(iv1)*t9*abb95n22+spvak2k6(iv2)*t8*abb95n22+spvak3k1(iv2)&
         &*t8*abb95n20+spvak3k4(iv2)*t8*abb95n23+t1*t9*abb95n24+t2*t9*abb95n26+t&
         &3*t9*abb95n25+t4*t9*abb95n25+t5*t9*abb95n27+t6*t9*abb95n20+t7*t9*abb95&
         &n23)
         return
      end if
      if(deg.eq.3) then
         numerator = (0.0_ki)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d95:
   subroutine     reconstruct_d95(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group2
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group2), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_95:
      coeffs%coeffs_95%c0 = derivative(czip)
      coeffs%coeffs_95%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_95%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_95%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_95%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_95%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_95%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_95%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_95%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_95%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_95%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_95%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_95%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_95%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_95%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_95%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_95%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_95%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_95%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_95%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_95%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_95%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_95%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_95%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_95%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_95%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_95%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_95%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_95%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_95%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_95%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_95%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_95%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_95%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_95%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_95:
   end subroutine reconstruct_d95
!---#] subroutine reconstruct_d95:
end module p9_udbar_neepgg_d95h1l1d
