module     p9_udbar_neepgg_d53h3l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity3/d53h3l1.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p9_udbar_neepgg_groups, only: &
!           & sign => diagram53_sign, shift => diagram53_shift
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd53h3
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d53
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k6-k5
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d53 = 0.0_ki
      t1 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t2 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t3 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t4 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      d53 = (abb53n2+t1*abb53n3+t2*abb53n5+abb53n10*(Q(1)*spvak2k5(1)-Q(2)*spvak&
      &2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))+abb53n11*(Q(1)*Q(1)-Q(2)*Q(2)-Q&
      &(3)*Q(3)-Q(4)*Q(4))+abb53n12*(Q(1)*spvak3k5(1)-Q(2)*spvak3k5(2)-Q(3)*spva&
      &k3k5(3)-Q(4)*spvak3k5(4))+abb53n4*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*&
      &k1(4))+abb53n6*(Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*s&
      &pvak6k1(4))+abb53n7*(Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q&
      &(4)*spvak5k1(4))+abb53n8*(Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6&
      &(3)-Q(4)*spvak2k6(4))+abb53n9*(Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spv&
      &ak3k6(3)-Q(4)*spvak3k6(4))+t1*t3*abb53n14+t1*t4*abb53n15+t2*t3*abb53n13+t&
      &2*t4*abb53n16)
      numerator = cmplx(real(d53, ki), aimag(d53), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd53h3
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d53
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k6-k5
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d53 = 0.0_ki
      t1 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t2 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t3 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t4 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      d53 = (abb53n2+t1*abb53n3+t2*abb53n5+abb53n10*(Q(1)*spvak2k5(1)-Q(2)*spvak&
      &2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))+abb53n11*(Q(1)*Q(1)-Q(2)*Q(2)-Q&
      &(3)*Q(3)-Q(4)*Q(4))+abb53n12*(Q(1)*spvak3k5(1)-Q(2)*spvak3k5(2)-Q(3)*spva&
      &k3k5(3)-Q(4)*spvak3k5(4))+abb53n4*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*&
      &k1(4))+abb53n6*(Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*s&
      &pvak6k1(4))+abb53n7*(Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q&
      &(4)*spvak5k1(4))+abb53n8*(Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6&
      &(3)-Q(4)*spvak2k6(4))+abb53n9*(Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spv&
      &ak3k6(3)-Q(4)*spvak3k6(4))+t1*t3*abb53n14+t1*t4*abb53n15+t2*t3*abb53n13+t&
      &2*t4*abb53n16)

      numerator = cmplx(real(d53, ki), aimag(d53), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p9_udbar_neepgg_d53h3l1
