module     p9_udbar_neepgg_d77h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity3/d77h3l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d77
contains

!---#[ function derivative:
   function derivative(mu2, i1) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd77h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      complex(ki) :: numerator
      complex(ki) :: loc
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k3+k2-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(deg.eq.0) then
         numerator = (abb77n16+abb77n30*(spvak2k5(1)*qshift(1)-spvak2k5(2)*qshif&
         &t(2)-spvak2k5(3)*qshift(3)-spvak2k5(4)*qshift(4))+abb77n31*(spvak3k5(1&
         &)*qshift(1)-spvak3k5(2)*qshift(2)-spvak3k5(3)*qshift(3)-spvak3k5(4)*qs&
         &hift(4))+abb77n32*(spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k&
         &1(3)*qshift(3)-spvak5k1(4)*qshift(4))+abb77n33*(spvak2k1(1)*qshift(1)-&
         &spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-spvak2k1(4)*qshift(4))+abb&
         &77n34*(spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(&
         &3)-spvak3k1(4)*qshift(4))+abb77n35*(spvak2k6(1)*qshift(1)-spvak2k6(2)*&
         &qshift(2)-spvak2k6(3)*qshift(3)-spvak2k6(4)*qshift(4))+abb77n36*dotpro&
         &duct(k5, qshift)+abb77n37*(spvak3k6(1)*qshift(1)-spvak3k6(2)*qshift(2)&
         &-spvak3k6(3)*qshift(3)-spvak3k6(4)*qshift(4))+abb77n38*(spvak6k1(1)*qs&
         &hift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-spvak6k1(4)*qshift&
         &(4))+abb77n39*dotproduct(k6, qshift)+abb77n40*dotproduct(k1, qshift)+a&
         &bb77n41*(spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshif&
         &t(3)-spvak6k5(4)*qshift(4))+abb77n42*(spvak5k6(1)*qshift(1)-spvak5k6(2&
         &)*qshift(2)-spvak5k6(3)*qshift(3)-spvak5k6(4)*qshift(4)))
         return
      end if
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb77n19+k5(iv1)*abb77n23+k6(iv1)*abb77n20+spvak2k&
         &1(iv1)*abb77n26+spvak2k5(iv1)*abb77n29+spvak2k6(iv1)*abb77n24+spvak3k1&
         &(iv1)*abb77n25+spvak3k5(iv1)*abb77n28+spvak3k6(iv1)*abb77n22+spvak5k1(&
         &iv1)*abb77n27+spvak5k6(iv1)*abb77n17+spvak6k1(iv1)*abb77n21+spvak6k5(i&
         &v1)*abb77n18)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d77:
   subroutine     reconstruct_d77(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group3
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group3), intent(out) :: coeffs
      ! rank 1 case:
      !---[# reconstruct coeffs%coeffs_77:
      coeffs%coeffs_77%c0 = derivative(czip)
      coeffs%coeffs_77%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_77%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_77%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_77%c1(4,1) = -derivative(czip,4)
      !---#] reconstruct coeffs%coeffs_77:
   end subroutine reconstruct_d77
!---#] subroutine reconstruct_d77:
end module p9_udbar_neepgg_d77h3l1d
