module     p9_udbar_neepgg_d82h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity3/d82h3l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d82
contains

!---#[ function derivative:
   function derivative(mu2, i1) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd82h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      complex(ki) :: numerator
      complex(ki) :: loc
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k3-k2+k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(deg.eq.0) then
         numerator = (abb82n14+abb82n15*(spvak2k1(1)*qshift(1)-spvak2k1(2)*qshif&
         &t(2)-spvak2k1(3)*qshift(3)-spvak2k1(4)*qshift(4))+abb82n16*(spvak3k1(1&
         &)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-spvak3k1(4)*qs&
         &hift(4))+abb82n17*(spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k&
         &6(3)*qshift(3)-spvak2k6(4)*qshift(4))+abb82n18*dotproduct(k6, qshift)+&
         &abb82n19*(spvak3k6(1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshi&
         &ft(3)-spvak3k6(4)*qshift(4))+abb82n20*(spvak2k5(1)*qshift(1)-spvak2k5(&
         &2)*qshift(2)-spvak2k5(3)*qshift(3)-spvak2k5(4)*qshift(4))+abb82n21*dot&
         &product(k1, qshift)+abb82n22*dotproduct(k5, qshift)+abb82n23*(spvak3k5&
         &(1)*qshift(1)-spvak3k5(2)*qshift(2)-spvak3k5(3)*qshift(3)-spvak3k5(4)*&
         &qshift(4))+abb82n24*(spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak&
         &6k1(3)*qshift(3)-spvak6k1(4)*qshift(4))+abb82n25*(spvak5k1(1)*qshift(1&
         &)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-spvak5k1(4)*qshift(4)))
         return
      end if
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb82n21+k5(iv1)*abb82n22+k6(iv1)*abb82n18+spvak2k&
         &1(iv1)*abb82n15+spvak2k5(iv1)*abb82n20+spvak2k6(iv1)*abb82n17+spvak3k1&
         &(iv1)*abb82n16+spvak3k5(iv1)*abb82n23+spvak3k6(iv1)*abb82n19+spvak5k1(&
         &iv1)*abb82n25+spvak6k1(iv1)*abb82n24)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d82:
   subroutine     reconstruct_d82(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group3
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group3), intent(out) :: coeffs
      ! rank 1 case:
      !---[# reconstruct coeffs%coeffs_82:
      coeffs%coeffs_82%c0 = derivative(czip)
      coeffs%coeffs_82%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_82%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_82%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_82%c1(4,1) = -derivative(czip,4)
      !---#] reconstruct coeffs%coeffs_82:
   end subroutine reconstruct_d82
!---#] subroutine reconstruct_d82:
end module p9_udbar_neepgg_d82h3l1d
