module     p9_udbar_neepgg_d95h3l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity3/d95h3l1.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p9_udbar_neepgg_groups, only: &
!           & sign => diagram95_sign, shift => diagram95_shift
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd95h3
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d95
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(+Q_ext(4),   ki_sam), aimag(+Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3), ki_sam), aimag(+Q_ext(1:3)), ki)
      d95 = 0.0_ki
      t1 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t2 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t3 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t4 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t5 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t6 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t7 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t8 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t9 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t10 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      t11 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      t12 = t5*abb95n25
      d95 = (abb95n1+t1*abb95n10+t10*abb95n7+t11*abb95n8+t12*t7+t12*t8+t2*abb95n&
      &11+t3*abb95n13+t4*abb95n2+t5*abb95n3+t6*abb95n4+t7*abb95n5+t8*abb95n5+t9*&
      &abb95n6+t1*t10*abb95n31+t1*t11*abb95n36+t1*t3*abb95n14+t1*t7*abb95n28+t1*&
      &t8*abb95n28+t1*t9*abb95n26+t10*t2*abb95n33+t10*t3*abb95n20+t10*t4*abb95n2&
      &1+t10*t5*abb95n32+t11*t2*abb95n38+t11*t3*abb95n34+t11*t4*abb95n35+t11*t5*&
      &abb95n37+t2*t4*abb95n23+t2*t5*abb95n24+t2*t6*abb95n23+t2*t7*abb95n30+t2*t&
      &8*abb95n30+t2*t9*abb95n29+t2*abb95n12*(Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-&
      &Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))+t2*abb95n22*(Q(1)*spvak2k4(1)-Q(2)*spv&
      &ak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))+t2*abb95n9*(Q(1)*spvak2k1(1)-&
      &Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))+t3*t6*abb95n15+t3*t7*&
      &abb95n16+t3*t8*abb95n16+t3*t9*abb95n17+t4*t7*abb95n18+t4*t8*abb95n18+t4*t&
      &9*abb95n19+t5*t9*abb95n27)
      numerator = cmplx(real(d95, ki), aimag(d95), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd95h3
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d95
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(+Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d95 = 0.0_ki
      t1 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t2 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t3 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t4 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t5 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t6 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t7 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t8 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t9 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t10 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      t11 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      t12 = t5*abb95n25
      d95 = (abb95n1+t1*abb95n10+t10*abb95n7+t11*abb95n8+t12*t7+t12*t8+t2*abb95n&
      &11+t3*abb95n13+t4*abb95n2+t5*abb95n3+t6*abb95n4+t7*abb95n5+t8*abb95n5+t9*&
      &abb95n6+t1*t10*abb95n31+t1*t11*abb95n36+t1*t3*abb95n14+t1*t7*abb95n28+t1*&
      &t8*abb95n28+t1*t9*abb95n26+t10*t2*abb95n33+t10*t3*abb95n20+t10*t4*abb95n2&
      &1+t10*t5*abb95n32+t11*t2*abb95n38+t11*t3*abb95n34+t11*t4*abb95n35+t11*t5*&
      &abb95n37+t2*t4*abb95n23+t2*t5*abb95n24+t2*t6*abb95n23+t2*t7*abb95n30+t2*t&
      &8*abb95n30+t2*t9*abb95n29+t2*abb95n12*(Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-&
      &Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))+t2*abb95n22*(Q(1)*spvak2k4(1)-Q(2)*spv&
      &ak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))+t2*abb95n9*(Q(1)*spvak2k1(1)-&
      &Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))+t3*t6*abb95n15+t3*t7*&
      &abb95n16+t3*t8*abb95n16+t3*t9*abb95n17+t4*t7*abb95n18+t4*t8*abb95n18+t4*t&
      &9*abb95n19+t5*t9*abb95n27)

      numerator = cmplx(real(d95, ki), aimag(d95), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p9_udbar_neepgg_d95h3l1
